datablock AudioProfile(RSMWeldingStartSound)
{
	filename = "./Welder_Start.wav";
	description = AudioClose3d;
	preload = false;
};

datablock AudioProfile(RSMWeldingStopSound)
{
	filename = "./Welder_Stop.wav";
	description = AudioClose3d;
	preload = false;
};

datablock AudioProfile(RSMWeldingLoopSound)
{
	filename = "./Welder_Loop.wav";
	description = AudioCloseLooping3d;
	preload = false;
};

datablock fxLightData(RSMArcWelderLight : PlayerLight)
{
	uiName = "";
	
	radius = 5;
	brightness = 5;
	color = "0.6 0.8 1 1";
	
	flareBitmap = "Add-Ons/Gamemode_Space_Mod/Arc Welder/lightArcWelder";
	flareColor = "1 1 1";
	ConstantSizeOn = 0;
	NearSize = 1;
	FarSize = 0.5;
	NearDistance = 10.0;
	FarDistance = 30.0;
};

datablock ShapeBaseImageData(RSMArcWelderImage)
{
	shapeFile = "Add-Ons/Gamemode_Space_Mod/Arc Welder/Arc Welder.dts";
	iconName = "./Icon_ArcWelder";
	emap = true;
	mountPoint = 0;
	offset = "-0.02 0 -0.15";
	eyeOffset = "0.7 0.7 -0.55";
	eyeRotation = eulerToMatrix("-30 0 0");
	rotation = eulerToMatrix("-15 0 0");
	correctMuzzleVector = true;
	className = "WeaponImage";
	item = RSMArcWelderItem;
	melee = true;
	armReady = true;
	doRetraction = false;
	doColorShift = false;
	
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "Ready";
	
	stateName[1] = "Ready";
	stateSequence[1] = "Ready";
	stateAllowImageChange[1] = true;
	stateTransitionOnTriggerDown[1] = "StartFire";
	
	stateName[2] = "StartFire";
	stateSequence[2] = "LoopFire";
	stateScript[2] = "onFire";
	stateAllowImageChange[2] = false;
	stateTimeoutValue[2] = 0.145;
	stateTransitionOnTimeout[2] = "LoopFire";
	stateTransitionOnTriggerUp[2] = "StopFire";
	stateSound[2] = RSMWeldingStartSound;
	
	stateName[3] = "LoopFire";
	stateSequence[3] = "LoopFire";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "StopFire";
	stateSound[3] = RSMWeldingLoopSound;
	
	stateName[4] = "StopFire";
	stateAllowImageChange[4] = false;
	stateTransitionOnTimeout[4] = "Ready";
	stateTimeoutValue[4] = 0.104;
	stateSequence[4] = "Ready";
	stateScript[4] = "onStopFire";
	stateSound[4] = RSMWeldingStopSound;
};

datablock ItemData(RSMArcWelderItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	shapeFile = "Add-Ons/Gamemode_Space_Mod/Arc Welder/Arc Welder.dts";
	iconName = "./Icon_ArcWelder";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Arc Welder";
	doColorShift = false;
	image = RSMArcWelderImage;
	canDrop = true;
};

function RSMArcWelderImage::onFire(%img, %pl, %slot)
{
	if(!isEventPending(%pl.arcWelderLoop))
		%pl.arcWelderLoop = %pl.schedule(50, "RSM_ArcWelderLoop", getSimTime());
	%pl.setImageTrigger(1, 1);
}

function RSMArcWelderImage::onStopFire(%img, %pl, %slot)
{
	cancel(%pl.arcWelderLoop);
	%pl.setImageTrigger(1, 0);
}

function Player::RSM_ArcWelderLoop(%pl, %last)
{
	if(!isObject(%pl) || %pl.getState() $= "DEAD" || %pl.getMountedImage(0).getName() !$= "RSMArcWelderImage")
		return;
	cancel(%pl.arcWelderLoop);
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType
		| $Typemasks::StaticObjectType | $Typemasks::TerrainObjectType
		| $Typemasks::VehicleObjectType;
	%eye = %pl.getEyePoint();
	%up = %pl.getUpVector();
	%dot = vectorDot(%pl.getEyeVector(), %up);
	%dir = vectorAdd(vectorScale(%pl.getForwardVector(), mSqrt(1 - %dot * %dot)), vectorScale(%up, %dot));
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 4)), %mask, %pl);
	%obj = firstWord(%ray);
	if(isObject(%obj))
	{
		%hitPos = getWords(%ray, 1, 3);
		%hitPos = vectorAdd(%hitPos, vectorScale(vectorNormalize(vectorSub(%hitPos, %eye)), -0.25));
		if(!isObject(%light = %pl.arcWelderLight))
			%light = (%pl.arcWelderLight = new fxLight(){datablock = RSMArcWelderLight;});
		else if(%light.getDatablock().getName() !$= "RSMArcWelderLight")
			%light.setDatablock(RSMArcWelderLight);
		%light.setTransform(%hitPos SPC "1 0 0 0");
		%light.reset(); cancel(%light.killSched);
		%light.killSched = %light.schedule(100, "delete");
	}
	%pl.arcWelderLoop = %pl.schedule(50, "RSM_ArcWelderLoop", %now);
}