datablock fxDTSBrickData(brick2xCubeData)
{
	brickFile = "./Bricks/2x Cube.blb";
	category = "Baseplates";
	subCategory = "Cube";
	uiName = "2x Cube";
};

function AsteroidGenTick()
{
	$AsteroidGen = schedule(1000, 0, "AsteroidGenTick");
	if(!isObject(AsteroidGroup)) new SimSet(AsteroidGroup);
	for(%i=AsteroidGroup.getCount()-1;%i>=0;%i--) { %asteroid = AsteroidGroup.getObject(%i); if(%asteroid.getCount() == 0) %asteroid.delete(); }
	if(!isObject(StationCores) || StationCores.getCount() == 0) return; 
	if(!isObject(Brickgroup_1337)) MainBrickgroup.add(new SimGroup(Brickgroup_1337) { bl_id = 1337; name = "the world"; });
	for(%i=0;%i<StationCores.getCount();%i++) { %core = StationCores.getObject(%i); if(%core.stationName !$= "Unnamed Station") %core[-1+%cores++] = %core; }
	if(AsteroidGroup.getCount() >= getMin(%cores * 10, 200)) return; %station = %core[getRandom(0, %cores - 1)];
	%center = vectorAdd(%station.getPosition(), vectorScale(getUnitVector(), getRandom($RSM::AsteroidDist * 2, $RSM::AsteroidDist * 3)));
	for(%i=0;%i<StationCores.getCount();%i++) if(vectorDist(%center, StationCores.getObject(%i).getPosition()) < $RSM::AsteroidDist * 2) return;
	for(%i=0;%i<AsteroidGroup.getCount();%i++) if(vectorDist(%center, AsteroidGroup.getObject(%i).centerPos) < $RSM::AsteroidDist) return;
	for(%i=0;%i<3;%i++) %center = setWord(%center, %i, (%val = mFloatLength(getWord(%center, %i), 0)) $= "-0" ? 0 : %val);
	CreateNewAsteroid(%center);
}

function CreateNewAsteroid(%center)
{
	if(!isObject(AsteroidGroup)) new SimSet(AsteroidGroup);
	if(!isObject(Brickgroup_1337)) MainBrickgroup.add(new SimGroup(Brickgroup_1337) { bl_id = 1337; name = "the world"; });
	%asteroid = new SimSet() { centerPos = %center; };
	%read = new FileObject();
	%read.openForRead("Add-Ons/Gamemode_Space_Mod/Asteroid Base.txt");
	while(!%read.isEOF()) %line[-1+%lines++] = %read.readLine();
	%read.close(); %read.delete();
	for(%i=0;%i<%lines;%i++)
	{
		%uiName = getSubStr(%line[%i], 0, %pos = strPos(%line[%i], "\""));
		if(!isObject(%data = $UINameTable[%uiName])) continue;
		%data = createBrick(Brickgroup_1337, %data, vectorAdd(getSubStr(%line[%i], %pos + 2, strLen(%line[%i]) - (%pos + 2)), %center), 6, 0);
		%brick = getField(%data, 0); %error = getField(%data, 1);
		if(%error && %error != 2)
		{
			for(%i=%asteroid.getCount()-1;%i>=0;%i--)
				%asteroid.getObject(%i).delete();
			%brick.delete(); %asteroid.delete(); return;
		}
		%asteroid.add(%brick); %brick.schedule(0, "addToAsteroid", %asteroid);
	}
	if(%asteroid.getCount() == 0) { %asteroid.delete(); return; }
	AsteroidGroup.add(%asteroid); return %asteroid;
}

function fxDtsBrick::addToAsteroid(%brick, %asteroid)
{ %brick.asteroidGroup = %asteroid; %brick.isAsteroid = 1; }

function fxDtsBrick::getMaxDist(%brick, %pos)
{
	%relPos = vectorSub(%brick.getPosition(), %pos);
	%data = %brick.getDatablock();
	if(%brick.getAngleID() % 2)
	{
		%size0 = %data.brickSizeY / 4;
		%size1 = %data.brickSizeX / 4;
	}
	else
	{
		%size0 = %data.brickSizeX / 4;
		%size1 = %data.brickSizeY / 4;
	}
	%size2 = %data.brickSizeZ / 10;
	for(%i=0;%i<3;%i++) %relPos = setWord(%relPos, %i, mAbs(getWord(%relPos, %i)) + %size[%i]);
	return vectorLen(%relPos);
}

function getUnitVector()
{
	%elev = mAsin(getRandom() * 2 - 1);
	%azim = (getRandom() * 2 - 1) * $PI;
	%z = mSin(%elev); %l = mCos(%elev);
	%x = mSin(%azim) * %l;
	%y = mCos(%azim) * %l;
	return %x SPC %y SPC %z;
}

if(!isEventPending($AsteroidGen)) AsteroidGenTick();