function brickFabricatorData::onAdd(%data, %brick)
{
	if(!%brick.isPlanted()) return;
	%brick.schedule(0, "addFabberCover");
	%brick.setVar("StartLockTime", 5);
	%brick.setVar("LockWhileBurning", 1);
	%brick.setVar("EndLockTime", 5);
	%brick.setVar("TrustLevel", 2);
}

function fxDtsBrick::addFabberCover(%brick)
{
	%cover = createBrick(%brick.getGroup(), brickFabricatorCoverData, %brick.getPosition(), %brick.getColorID(), %brick.getAngleID());
	%brick.fabberCover = firstWord(%cover); %cover.mainFabber = %brick;
}

function brickFabricatorData::onRemove(%data, %brick)
{
	if(!%brick.isPlanted()) return;
	if(isObject(%cover = %brick.fabberCover)) { %cover.mainFabber = ""; %cover.delete(); }
}

function brickFabricatorCoverData::onRemove(%data, %brick)
{
	if(!%brick.isPlanted()) return;
	if(isObject(%main = %brick.mainFabber)) { %main.fabberCover = ""; %main.delete(); }
}

function fxDtsBrick::useFabricator(%brick, %this)
{
	if(isObject(%cl = %this.client) && %brick.getDatablock().isFabricator)
	{
		if(!isObject(%main = %brick.mainFabber)) %main = %brick;
		if(!isObject(%cover = %main.fabberCover)) return;
		if(getTrustLevel(%cl, %main.getGroup()) < %main.getVar("TrustLevel")) return;
		commandToClient(%cl, 'OpenFabberGUI');
		if(!isObject(%main.lockHolder))
		{
			%main.lockHolder = %cl;
			%main.lockStart = getSimTime();
			%main.lockLength = %main.getVar("StartLockTime");
			%main.lockClear = %main.schedule(%main.getVar("StartLockTime") * 1000, "clearLockHolder");
		}
		else if(%cl != %main.lockHolder)
		{
			for(%i=0;%i<%main.pendingLockHolders;%i++)
				if(%cl = %main.pendingLockHolder[%i]) %isPending = 1;
			if(!%isPending) %main.pendingLockHolder[-1+%main.pendingLockHolders++] = %cl;
		}
		if(%cl.brickgroup == %main.getGroup())
			%fabberSettings = %main.getVar("StartLockTime") SPC %main.getVar("LockWhileBurning") SPC %main.getVar("EndLockTime") SPC %main.getVar("TrustLevel");
		commandToClient(%cl, 'FabberLockHolder', %main.lockHolder.name, %main.lockLength - vectorDist(%main.lockStart, getSimTime()) / 1000, %cl == %main.lockHolder, %fabberSettings);
		if(isEventPending(%main.burnSched)) commandToClient(%cl, 'FabberBurnTime', vectorDist(%main.burnStart, getSimTime()) / 1000, %main.burnLength);
		for(%i=0;%i<6;%i++) commandToClient(%cl, 'FabberUpdateItem', %i, %main.itemSlot[%i]);
		%this.usingFabber = %main; %this.FabberGUILoop(); %main.updateRecipeList(%cl);
		return 1;
	}
	return 0;
}

package Fabricator
{
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		if(isObject(%cl = %this.client) && %trig == 0 && %tog && !isObject(%this.getMountedImage(0)))
		{
			%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::VehicleObjectType;
			%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
			%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 8)), %mask, %this);
			if(isObject(%obj = firstWord(%ray)) && (%obj.getType() & $Typemasks::fxBrickAlwaysObjectType))
			{
				for(%i=0;%i<%obj.numEvents;%i++) if(%obj.eventInput[%i] $= "onActivate") %cancelFabber = 1;
				if(!%cancelFabber) if(%obj.useFabricator(%this)) return;
			}
		}
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function fxDtsBrick::setColliding(%brick, %value)
	{
		Parent::setColliding(%brick, %value);
		%dataName = %brick.getDatablock().getName();
		switch$(%dataName)
		{
			case "brickFabricatorData":
				if(isObject(%cover = %brick.fabberCover))
				{
					%cover.mainFabber = "";
					%cover.setColliding(%value);
					%cover.mainFabber = %brick;
				}
			case "brickFabricatorCoverData":
				if(isObject(%main = %brick.mainFabber))
				{
					%main.fabberCover = "";
					%main.setColliding(%value);
					%main.fabberCover = %brick;
				}
		}
	}
	
	function fxDtsBrick::setColor(%brick, %color)
	{
		Parent::setColor(%brick, %color);
		%dataName = %brick.getDatablock().getName();
		switch$(%dataName)
		{
			case "brickFabricatorData":
				if(isObject(%cover = %brick.fabberCover))
				{
					%cover.mainFabber = "";
					%cover.setColor(%color);
					%cover.mainFabber = %brick;
				}
			case "brickFabricatorCoverData":
				if(isObject(%main = %brick.mainFabber))
				{
					%main.fabberCover = "";
					%main.setColor(%color);
					%main.fabberCover = %brick;
				}
		}
	}
	
	function fxDtsBrick::setRaycasting(%brick, %value)
	{
		Parent::setRaycasting(%brick, %value);
		%dataName = %brick.getDatablock().getName();
		switch$(%dataName)
		{
			case "brickFabricatorData":
				if(isObject(%cover = %brick.fabberCover))
				{
					%cover.mainFabber = "";
					%cover.setRaycasting(%value);
					%cover.mainFabber = %brick;
				}
			case "brickFabricatorCoverData":
				if(isObject(%main = %brick.mainFabber))
				{
					%main.fabberCover = "";
					%main.setRaycasting(%value);
					%main.fabberCover = %brick;
				}
		}
	}
	
	function fxDtsBrick::setRendering(%brick, %value)
	{
		Parent::setRendering(%brick, %value);
		%dataName = %brick.getDatablock().getName();
		switch$(%dataName)
		{
			case "brickFabricatorData":
				if(isObject(%cover = %brick.fabberCover))
				{
					%cover.mainFabber = "";
					%cover.setRendering(%value);
					%cover.mainFabber = %brick;
				}
			case "brickFabricatorCoverData":
				if(isObject(%main = %brick.mainFabber))
				{
					%main.fabberCover = "";
					%main.setRendering(%value);
					%main.fabberCover = %brick;
				}
		}
	}
};
activatePackage("Fabricator");

function servercmdFabberSetSetting(%cl, %setting, %value)
{
	if(!isObject(%pl = %cl.player)) return;
	if(!isObject(%fabber = %pl.usingFabber)) return;
	if(%cl.brickgroup != %fabber.getGroup()) return;
	switch$(%setting)
	{
		case "StartLockTime":
			%valid = "0123456789";
			%len = strLen(%value);
			for(%i=0;%i<%len;%i++)
				if(strPos(%valid, getSubStr(%value, %i, 1)) == -1) return;
			if(%value > 300) %value = 300;
			%fabber.setVar("StartLockTime", %value);
		case "BurningLock": %fabber.setVar("LockWhileBurning", !!%value);
		case "EndLockTime":
			%valid = "0123456789";
			%len = strLen(%value);
			for(%i=0;%i<%len;%i++)
				if(strPos(%valid, getSubStr(%value, %i, 1)) == -1) return;
			if(%value > 300) %value = 300;
			%fabber.setVar("EndLockTime", %value);
		case "TrustLevel":
			%valid = "0123";
			if(strPos(%valid, %value) == -1) return;
			%fabber.setVar("TrustLevel", %value);
	}
}

function servercmdFabberInsertItem(%cl, %item)
{
	if(!isObject(%pl = %cl.player)) return;
	if(!isObject(%fabber = %pl.usingFabber)) return;
	if(isObject(%locker = %fabber.lockHolder) && %locker != %cl) return;
	%type = firstWord(%item);
	%item = restWords(%item);
	if(%type $= "Mat")
	{
		for(%i=0;%i<3;%i++)
		{
			%fabberItem = %fabber.itemSlot[%i];
			%words = getWordCount(%fabberItem);
			if(getWords(%fabberItem, 0, %words - 2) $= ("Mat "@%item))
			{
				%list = materialList();
				%count = getFieldCount(%list);
				for(%j=0;%j<%count;%j++)
					if(getField(%list, %j) $= %item)
					{ %foundMat = 1; break; }
				if(!%foundMat) return;
				if(%cl.mat[%item] <= 0) return;
				%fabber.itemSlot[%i] = "Mat "@%item SPC getWord(%fabberItem, %words - 1) + %cl.mat[%item];
				%cl.totalMats -= %cl.mat[%item]; %cl.mat[%item] = 0;
				commandToClient(%cl, 'UpdateMaterial', 0, %item);
				%count = ClientGroup.getCount();
				for(%j=0;%j<%count;%j++)
				{
					%cl = ClientGroup.getObject(%j);
					if(isObject(%pl = %cl.player) && %pl.usingFabber == %fabber)
						for(%k=0;%k<6;%k++) commandToClient(%cl, 'FabberUpdateItem', %k, %fabber.itemSlot[%k]);
				}
				%fabber.updateRecipeList();
				return;
			}
		}
	}
	for(%i=0;%i<3;%i++)
		if(%fabber.itemSlot[%i] $= "")
		{ %slot = %i; break; }
	if(%slot $= "") return;
	switch$(%type)
	{
		case "Mat":
			%list = materialList();
			%count = getFieldCount(%list);
			for(%i=0;%i<%count;%i++)
				if(getField(%list, %i) $= %item)
				{ %foundMat = 1; break; }
			if(!%foundMat) return;
			if(%cl.mat[%item] <= 0) return;
			%fabber.itemSlot[%slot] = "Mat "@%item SPC %cl.mat[%item];
			%cl.totalMats -= %cl.mat[%item]; %cl.mat[%item] = 0;
			commandToClient(%cl, 'UpdateMaterial', 0, %item);
		default: return;
	}
	%fabber.currRecipe = "";
	for(%i=3;%i<6;%i++)
	{
		%data = %fabber.itemSlot[%i];
		if(getWord(%data, getWordCount(%data) - 1) $= "Ghost")
			%fabber.itemSlot[%i] = "";
		else if(firstWord(%data) $= "GhostItem")
			%fabber.itemSlot[%i] = "";
	}
	if(isEventPending(%fabber.burnSched))
	{
		cancel(%fabber.burnSched);
		%fabber.lockStart = getSimTime();
		%fabber.lockLength = %fabber.getVar("EndLockTime");
		%fabber.lockClear = %fabber.schedule(%fabber.getVar("EndLockTime") * 1000, "clearLockHolder");
	}
	%fabber.updateClientData();
	%fabber.updateRecipeList();
}

function servercmdFabberRemoveItem(%cl, %slot)
{
	if(!isObject(%pl = %cl.player)) return;
	if(!isObject(%fabber = %pl.usingFabber)) return;
	if(isObject(%locker = %fabber.lockHolder) && %locker != %cl) return;
	if(%fabber.itemSlot[%slot] $= "") return;
	%fabber.currRecipe = "";
	%item = %fabber.itemSlot[%slot];
	%type = firstWord(%item);
	%item = restWords(%item);
	%words = getWordCount(%item);
	switch$(%type)
	{
		case "Mat":   //Add backpack limit checking
			%mat = getWords(%item, 0, %words - 2);
			%cl.mat[%mat] += getWord(%item, %words - 1);
			%cl.totalMats += getWord(%item, %words - 1);
			commandToClient(%cl, 'UpdateMaterial', %cl.mat[%mat], %mat);
			if(%slot < 3)
			{
				%fabber.itemSlot[%slot] = "";
				for(%i=3;%i<6;%i++)
				{
					%data = %fabber.itemSlot[%i];
					if(getWord(%data, getWordCount(%data) - 1) $= "Ghost")
						%fabber.itemSlot[%i] = "";
					else if(firstWord(%data) $= "GhostItem")
						%fabber.itemSlot[%i] = "";
				}
				if(isEventPending(%fabber.burnSched))
				{
					cancel(%fabber.burnSched);
					%fabber.lockStart = getSimTime();
					%fabber.lockLength = %fabber.getVar("EndLockTime");
					%fabber.lockClear = %fabber.schedule(%fabber.getVar("EndLockTime") * 1000, "clearLockHolder");
				}
			}
			else %fabber.itemSlot[%slot] = "Mat "@%mat@" Ghost";
			%fabber.updateClientData();
			%fabber.updateRecipeList();
	}
}

function servercmdFabberSelectRecipe(%cl, %recipe)
{
	if(!isObject(%pl = %cl.player)) return;
	if(!isObject(%fabber = %pl.usingFabber)) return;
	if(isObject(%locker = %fabber.lockHolder) && %locker != %cl) return;
	%recipeMeltIce = "Mat Ice\t\t\tMat Water\t\t";
	%recipeElectrolysis = "Mat Water\t\t\tMat Hydrogen\tMat Oxygen\t";
	%recipeMakeWater = "Mat Hydrogen\tMat Oxygen\t\tMat Water\t\t";
	%recipeMakeHydrazine = "Mat Hydrogen\tMat Nitrogen\t\tMat Hydrazine\t\t";
	%recipeBreakHydrazine = "Mat Hydrazine\t\t\tMat Hydrogen\tMat Nitrogen\t";
	%recipeMakeSteel = "Mat Iron\tMat Carbon\t\tMat Steel\t\t";
	%recipeMakeGun = "Mat Steel\t\t\tItem Gun\t\t";
	if(%recipe[%recipe] $= "") return;
	for(%i=3;%i<6;%i++)
	{ %item = %fabber.itemSlot[%i]; if(%item !$= "" && getWord(%item, getWordCount(%item) - 1) !$= "Ghost") return; }
	for(%i=0;%i<3;%i++)
	{
		%item = %fabber.itemSlot[%i];
		if(firstWord(%item) $= "Mat")
			%item = getWords(%item, 0, getWordCount(%item) - 2);
		%list = %list TAB %item;
	}
	%list = %list@"\t";
	%matReqs = getFields(%recipe[%recipe], 0, 2);
	for(%j=0;%j<3;%j++)
	{
		%req = getField(%matReqs, %j);
		if(%req !$= "" && striPos(%list, "\t"@%req@"\t") == -1)
			%reqFailed = 1;
	}
	%recList = "\t"@%matReqs@"\t";
	for(%j=0;%j<3;%j++)
	{
		%req = getField(%list, %j);
		if(%req !$= "" && striPos(%recList, "\t"@%req@"\t") == -1)
			%reqFailed = 1;
	}
	if(%reqFailed) return;
	for(%i=3;%i<6;%i++)
	{
		%field = getField(%recipe[%recipe], %i);
		if(%field $= "") continue;
		if(firstWord(%field) $= "Mat")
			%fabber.itemSlot[%i] = %field@" Ghost"; 
		else %fabber.itemSlot[%i] = "Ghost"@%field;
	}
	%fabber.currRecipe = %recipe;
	%fabber.checkBurning(%cl, 1);
	%count = ClientGroup.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(isObject(%pl = %cl.player) && %pl.usingFabber == %fabber)
			for(%j=0;%j<6;%j++) commandToClient(%cl, 'FabberUpdateItem', %j, %fabber.itemSlot[%j]);
	}
}

function RecipeList()
{
	return "Mat Ice\t\t\tMat Water\t\t\tMeltIce\n"
		@"Mat Water\t\t\tMat Hydrogen\tMat Oxygen\t\tElectrolysis\n"
		@"Mat Hydrogen\tMat Oxygen\t\tMat Water\t\t\tMakeWater\n"
		@"Mat Hydrogen\tMat Nitrogen\t\tMat Hydrazine\t\t\tMakeHydrazine\n"
		@"Mat Hydrazine\t\t\tMat Hydrogen\tMat Nitrogen\t\tBreakHydrazine\n"
		@"Mat Iron\tMat Carbon\t\tMat Steel\t\t\tMakeSteel\n";
		//@"Mat Steel\t\t\tItem Gun\t\t\tMakeGun";
}

function fxDtsBrick::checkBurning(%brick, %cl, %preburn)
{
	if(isEventPending(%brick.burnSched)) return;
	%recipeMeltIce = "Mat Ice 1\nMat Water 1\n3";
	%recipeElectrolysis = "Mat Water 1\nMat Hydrogen 0.112\tMat Oxygen 0.888\n15";
	%recipeMakeWater = "Mat Hydrogen 0.112\tMat Oxygen 0.888\nMat Water 1\n5";
	%recipeMakeHydrazine = "Mat Hydrogen 0.126\tMat Nitrogen 0.874\nMat Hydrazine 1\n15";
	%recipeBreakHydrazine = "Mat Hydrazine 1\nMat Hydrogen 0.126\tMat Nitrogen 0.874\n5";
	%recipeMakeSteel = "Mat Iron 0.998\tMat Carbon 0.002\nMat Steel 1\n5";
	//%recipeMakeGun = "Mat Steel 1.984\nItem Gun\n20";
	%recipe = %recipe[%brick.currRecipe];
	if(%recipe $= "") return 0;
	%reqList = getLine(%recipe, 0);
	%reqs = getFieldCount(%reqList);
	for(%i=0;%i<%reqs;%i++)
	{
		%satisfiedReq = 0;
		%req = getField(%reqList, %i);
		%type = firstWord(%req);
		%item = restWords(%req);
		%words = getWordCount(%item);
		switch$(%type)
		{
			case "Mat":
				for(%j=0;%j<3;%j++)
				{
					%slot = %brick.itemSlot[%j];
					if(getWords(%slot, 0, getWordCount(%slot) - 2) $= getWords(%req, 0, %words - 1))
					{
						if(getWord(%slot, getWordCount(%slot) - 1) >= getWord(%item, %words - 1))
							%satisfiedReq = 1;
					}
				}
		}
		if(!%satisfiedReq) return 0;
	}
	if(%preburn)
	{
		if(%brick.getVar("LockWhileBurning"))
		{
			cancel(%brick.lockClear);
			%brick.lockStart = -1;
			%brick.lockLength = 0;
			%brick.lockHolder = %cl;
		}
		%brick.burnStart = getSimTime(); %brick.burnLength = getLine(%recipe, 2);
		%brick.burnSched = %brick.schedule(%brick.burnLength * 1000, "checkBurning", %cl, 0);
		%brick.updateClientData(); return 1;
	}
	else
	{
		%items = getLine(%recipe, 1);
		for(%i=0;%i<3;%i++)
		{
			%data = getField(%items, %i);
			%type = firstWord(%data);
			%item = restWords(%data);
			%words = getWordCount(%item);
			%slot = %brick.itemSlot[%i + 3];
			switch$(%type)
			{
				case "": continue;
				case "Mat":
					if(getWords(%slot, 0, getWordCount(%slot) - 2) $= getWords(%data, 0, %words - 1))
						%brick.itemSlot[%i + 3] = setWord(%slot, %words, getWord(%slot, %words) + getWord(%item, %words - 1));
					else %brick.itemSlot[%i + 3] = %data;
				default: %brick.itemSlot[%i + 3] = %data;
			}
		}
		%items = getLine(%recipe, 0);
		for(%i=0;%i<3;%i++)
		{
			%data = getField(%items, %i);
			%type = firstWord(%data);
			%item = restWords(%data);
			%words = getWordCount(%item);
			switch$(%type)
			{
				case "": continue;
				case "Mat":
					for(%j=0;%j<3;%j++)
					{
						%slot = %brick.itemSlot[%j];
						if(getWords(%slot, 0, getWordCount(%slot) - 2) $= getWords(%data, 0, %words - 1))
							%brick.itemSlot[%j] = setWord(%slot, %words, getWord(%slot, %words) - getWord(%item, %words - 1));
						if(getWord(%brick.itemSlot[%j], getWordCount(%slot) - 1) <= 0) %brick.itemSlot[%j] = "";
					}
			}
		}
		%lTime = %brick.getVar("EndLockTime");
		if(!isEventPending(%brick.lockClear) || getTimeRemaining(%brick.lockClear) < %lTime * 1000)
		{
			cancel(%brick.lockClear);
			%brick.lockStart = getSimTime();
			%brick.lockLength = %lTime;
			%brick.lockHolder = %cl;
			%brick.lockClear = %brick.schedule(%lTime * 1000, "clearLockHolder");
		}
		%brick.updateClientData();
		%brick.checkBurning(%cl, 1);
	}
}

function fxDtsBrick::updateClientData(%brick)
{
	%count = ClientGroup.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(isObject(%pl = %cl.player) && %pl.usingFabber == %brick)
		{
			%brickSettings = "";
			if(%cl.brickgroup == %brick.getGroup())
				%brickSettings = %brick.getVar("StartLockTime") SPC %brick.getVar("LockWhileBurning") SPC %brick.getVar("EndLockTime") SPC %brick.getVar("TrustLevel");
			if(isObject(%brick.lockHolder)) commandToClient(%cl, 'FabberLockHolder', %brick.lockHolder.name, %brick.lockLength - vectorDist(%brick.lockStart, getSimTime()) / 1000, %cl == %brick.lockHolder, %brickSettings);
			for(%j=0;%j<6;%j++) commandToClient(%cl, 'FabberUpdateItem', %j, %brick.itemSlot[%j]);
			if(isEventPending(%brick.burnSched)) commandToClient(%cl, 'FabberBurnTime', vectorDist(%brick.burnStart, getSimTime()) / 1000, %brick.burnLength);
			else commandToClient(%cl, 'FabberBurnTime', 0, 0);
		}
	}
}

function fxDtsBrick::updateRecipeList(%brick, %cl)
{
	if(isObject(%cl)) commandToClient(%cl, 'FabberClearRecipes');
	else
	{
		%count = ClientGroup.getCount();
		for(%j=0;%j<%count;%j++)
		{
			%this = ClientGroup.getObject(%j);
			if(isObject(%pl = %this.player) && %pl.usingFabber == %brick)
				commandToClient(%this, 'FabberClearRecipes');
		}
	}
	%recipes = RecipeList();
	for(%i=0;%i<3;%i++)
	{
		%item = %brick.itemSlot[%i];
		if(firstWord(%item) $= "Mat")
			%item = getWords(%item, 0, getWordCount(%item) - 2);
		%list = %list TAB %item;
	}
	%list = %list@"\t";
	%lines = getLineCount(%recipes);
	for(%i=0;%i<%lines;%i++)
	{
		%reqFailed = 0;
		%recipe = getLine(%recipes, %i);
		for(%j=0;%j<3;%j++)
		{
			%req = getField(%recipe, %j);
			if(%req !$= "" && striPos(%list, "\t"@%req@"\t") == -1)
				%reqFailed = 1;
		}
		%recList = "\t"@getFields(%recipe, 0, 2)@"\t";
		for(%j=0;%j<3;%j++)
		{
			%req = getField(%list, %j + 1);
			if(%req !$= "" && striPos(%recList, "\t"@%req@"\t") == -1)
				%reqFailed = 1;
		}
		if(!%reqFailed)
		{
			if(isObject(%cl)) commandToClient(%cl, 'FabberAddRecipe', getField(%recipe, 3),
				getField(%recipe, 4), getField(%recipe, 5), getField(%recipe, 6));
			else
			{
				%count = ClientGroup.getCount();
				for(%j=0;%j<%count;%j++)
				{
					%this = ClientGroup.getObject(%j);
					if(isObject(%pl = %this.player) && %pl.usingFabber == %brick)
						commandToClient(%this, 'FabberAddRecipe', getField(%recipe, 3),
							getField(%recipe, 4), getField(%recipe, 5), getField(%recipe, 6));
				}
			}
		}
	}
}

function fxDtsBrick::clearLockHolder(%brick)
{
	cancel(%brick.lockClear); %brick.lockHolder = "";
	for(%i=0;%i<%brick.pendingLockHolders;%i++)
	{
		%cl = %brick.pendingLockHolder[%i]; %shift++;
		if(!isObject(%pl = %cl.player)) continue;
		if(vectorDist(%pl.getHackPosition(), %brick.getPosition()) > 8) continue;
		if(%pl.usingFabber != %brick) continue; %locker = %cl; break;
	}
	for(%i=0;%i<%brick.pendingLockHolders;%i++)
		%brick.pendingLockHolder[%i] = %brick.pendingLockHolder[%i + %shift];
	%brick.pendingLockHolders -= %shift;
	if(isObject(%locker))
	{
		%brick.lockHolder = %locker;
		%brick.lockStart = getSimTime();
		%brick.lockLength = %brick.getVar("StartLockTime");
		%brick.lockClear = %brick.schedule(%brick.getVar("StartLockTime") * 1000, "clearLockHolder");
		%brick.updateClientData();
	}
}

function servercmdFabberGUIClosed(%cl)
{ if(!isObject(%pl = %cl.player)) return; cancel(%pl.FabberGUILoop); %pl.usingFabber = ""; %pl.fabberInfo = ""; }

function Player::FabberGUILoop(%pl)
{
	cancel(%pl.FabberGUILoop); %cl = %pl.client;
	if(!isObject(%fabber = %pl.usingFabber) || vectorDist(%pl.getHackPosition(), %fabber.getPosition()) > 8)
	{ commandToClient(%cl, 'CloseFabberGUI'); %pl.usingFabber = ""; %pl.fabberInfo = ""; return; }
	%pl.FabberGUILoop = %pl.schedule(16, "FabberGUILoop");
}

function StaticShape::FabricationLoop(%sphere, %fabber, %last)
{
	cancel(%sphere.fabberSched);
	if(!isObject(%fabber)) { %sphere.delete(); return; }
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%dist = vectorDist(%pos = %fabber.getPosition(), %loc = %sphere.getPosition());
	%speed = 2.5;
	if(%dist == 0)
	{
		if(!%fabber.fabberCover.isColliding())
		{
			%cover = %fabber.fabberCover;
			%cover.mainFabber = "";
			%cover.disappear(0);
			%cover.mainFabber = %fabber;
		}
	}
	else if(%dist <= %time * %speed) %sphere.setTransform(%pos@" 1 0 0 0");
	else
	{
		%dir = vectorNormalize(vectorSub(%pos, %loc));
		%sphere.setTransform(vectorAdd(%loc, vectorScale(%dir, %time * %speed)));
	}
	%sphere.fabberSched = %sphere.schedule(16, "fabricationLoop", %fabber, %now);
}

function getSign(%value)
{ if(%value > 0) return 1; else if(%value < 0) return -1; return 0; }