$RSM::RequiredRSCVersion = 27;
$RSM::LatestRSCVersion = 27;	//Latest RS Client revision.
$RSM::WelcomeMessage = "\c2Welcome to Realistic Space Mod, \c3%1\c2!";

exec("./Validate Prefs.cs");
RSM_ValidatePrefs();

addDamageType("Silent", '', '', 1, 1);

//remove if packaging as a gamemode proves impossible
//if(!$RSM_LoadedSupportAddOns)
//{
//	%file = findFirstFile("Add-Ons/Brick_*/Server.cs");
//	while(%file !$= "")
//	{
//		%addon = getSubStr(%path = filePath(%file), 8, strLen(%path) - 8);
//		if($AddOn__[%addon] == 1) exec(%file);
//		%file = findNextFile("Add-Ons/Brick_*/Server.cs");
//	}
//	$RSM_LoadedSupportAddOns = 1;
//}

function RSM_SetEnvironment()
{
	if(isObject(NoGravZone))
		NoGravZone.delete();
	new PhysicalZone(NoGravZone)
	{
		position = "-50000 50000 -50000";
		scale = "100000 100000 100000";
		extraDrag = -0.1;
		gravityMod = 0;
		polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
	};
	//MissionGroup.add(%zone);
}
RSM_SetEnvironment();

function Player::setLeakAudio(%pl)
{
	if(!isObject(%cl = %pl.client)) return;
	if(%pl.species $= "Robot")
		%cl.suitDamage = 0;
	%audio = getMin(mCeil(%cl.suitDamage / 0.025), 5);
	if(%cl.hat != 1 || %cl.accent != 1) %audio = 0;
	if(%audio !$= %pl.currLeakAudio)
	{
		if(%audio >= 1) %pl.playAudio(1, ("OxyHiss"@%audio).getID());
		else %pl.stopAudio(1); %pl.currLeakAudio = %audio;
	}
}

package RealSpace
{
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		if(!isObject(%cl = %this.client) || %cl.choosingSpecies) return;
		if(%trig == 0 && isObject(%obj = %this.draggingOOGer) && %data.getID() == RealSpacePlayer.getID() && !isObject(%this.getMountedImage(0)))
		{
			if(vectorDist(%this.startedDragging, %now = getSimTime()) < 500)
			{
				if(vectorDist(%obj.lastPushTime, %now) >= 1000 && vectorDist(%this.lastPushTime, %now) >= 1000)
				{
					//Make Newtonian when out-of-game clients have material lists
					%dir = %this.getEyeVector();
					%obj.addVelocity(vectorScale(%dir, 2));
					%this.addVelocity(vectorScale(%dir, -2));
					%obj.lastPushTime = %now; %pl.lastPushTime = %now;
				}
			}
			cancel(%this.draggingLoop);
			%obj.beingDragged = 0;
		}
		if(%trig == 0 && %tog && %data.getID() == RealSpacePlayer.getID() && !isObject(%this.getMountedImage(0)))
		{
			%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::VehicleObjectType;
			%eye = %this.getEyePoint(); %dir = %this.getEyeVector();
			%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 4)), %mask, %this);
			if(isObject(%obj = firstWord(%ray)))
			{
				if(%obj.getType() & $Typemasks::PlayerObjectType)
				{
					if(%obj == %this.TetherBuddy)
					{ servercmdUntether(%cl); return; }
					if(isObject(%targ = %obj.client))
					{
						if(%targ.getClassName() $= "GameConnection")
						{
							if(isEventPending(%cl.TetherTimeout)) return;
							if(isEventPending(%targ.TetherTimeout)) return;
							if(%targ.autoRejectTethers) return;
							commandToClient(%targ, 'MessageBoxYesNo', %cl.name@" wants to tether",
								%cl.name@" wishes to tether to you.\r\nThis will keep you from drifting away from him/her.\r\nDo you accept?",
								'AcceptLastTether'); %targ.LastTetherer = %cl;
							%cl.chatMessage("\c6Invited \c2"@%targ.name@"\c6 to tether.");
							%cl.TetherTimeout = schedule(15000, 0, "doNothing");
							%targ.TetherTimeout = schedule(15000, 0, "doNothing");
						}
						else if(!isObject(%obj.beingDragged))
						{
							%this.draggingOOGer = %obj;
							%this.startedDragging = (%now = getSimTime());
							%this.draggingLoop = %this.schedule(16, "dragOOGer", %obj, %now);
							%obj.beingDragged = %this; %obj.handholdPos = "";
						}
					}
					else
					{
						%this.TetherBuddy = %obj;
						%obj.TetherBuddy = %this;
						TetherLoop(%this, %obj, getSimTime());
						%cl.chatMessage("\c6You have been tethered to \c2Bot\c6.");
					}
					%this.playThread(0, "activate");
					return;
				}
				else if(%obj.getName() $= "_FuelRefill")
				{
					if(isObject(%core = %obj.stationCore))
					{
						%refuel = mFloor(getMin(mFloatLength(%core.matHydrazine, 3) * 10, (100 - %this.getEnergyLevel()) / 2)) * 2;
						%this.setEnergyLevel(%this.getEnergyLevel() + %refuel); %cl.persistentFuel += %refuel; %core.matHydrazine -= (%refuel / 20);
					}
					Parent::onTrigger(%data, %this, %trig, %tog); return;
				}
			//	else if(%obj.getName() $= "_OxyRefill")
			//	{
			//		if(%this.oxygenLevel <= 95 && %cl.hat == 1 && %cl.accent == 1 && !isEventPending(%this.oxyTimeout))
			//		{
			//			%this.oxygenLevel += 5;
			//			%cl.persistentOxygen += 5;
			//			if(%obj.isRaycasting()) %obj.schedule(60000, "setRaycasting", 1);
			//			if(%obj.isColliding()) %obj.schedule(60000, "setColliding", 1);
			//			if(%obj.isRendering()) %obj.schedule(60000, "setRendering", 1);
			//			%obj.disappear(-1); %this.oxyTimeout = schedule(15000, 0, "doNothing");
			//		}
			//		return;
			//	}
			}
			%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 6 + vectorDot(%dir, "0 0 -1") * 1.5)), %mask, %this);
			if(isObject(%obj = firstWord(%ray)) && (%obj.getType() & $Typemasks::fxBrickAlwaysObjectType))
			{
				%dirList = "FBLRUD"; for(%i=0;%i<6;%i++) if(isEventPending(%pl.JetpackLoop[getSubStr(%dirList, %i, 1)])) %cancelGrab = 1;
				for(%i=0;%i<%obj.numEvents;%i++) if(%obj.eventInput[%i] $= "onActivate") %cancelGrab = 1;
				if(!%cancelGrab) %this.handholdPos = getWords(%ray, 1, 3);
			}
			Parent::onTrigger(%data, %this, %trig, %tog);
		}
		else if(%trig == 2 && %tog && %this.handholdPos !$= "")
		{
			%dir = %this.getEyeVector();
			%dotGrab = vectorDot(vectorNormalize(vectorSub(%this.getHackPosition(), %this.handholdPos)), %dir);
			%dotMove = vectorDot(vectorNormalize(%this.getVelocity()), %dir) * vectorLen(%this.getVelocity());
			%this.addVelocity(vectorScale(%dir, getMax(getMin((%dotGrab + 1) * 3 - %dotMove, 3.75), 0)));
			%this.handholdPos = "";
		}
		else if(%trig == 4 && isObject(%img = %this.getMountedImage(0)) && %img.getName() $= "brickImage")
		{
			if(!%tog) return;
			%eye = %this.getEyePoint();
			%dir = %this.getEyeVector();
			%ray = containerRaycast(%eye, %end = vectorAdd(%eye, vectorScale(%dir, 8)), $Typemasks::fxBrickObjectType);
			if(isObject(%obj = firstWord(%ray)))
			{
				%angle = mFloatLength(mAtan(getWord(%for = %this.getForwardVector(), 0), getWord(%for, 1)) / ($PI / 2), 0) + 1; if(%angle == -1) %angle = 3;
				if(isObject(%temp = %this.tempbrick))
					%brickData = %this.tempbrick.getDatablock();
				else if(!isObject(%cl = %this.client) || %cl.currInv == -1) return;
				else %brickData = %cl.inventory[%cl.currInv];
				if((%angle + %brickData.orientationFix) % 2)
				{
					%xVal = %brickData.brickSizeY * 0.25;
					%yVal = %brickData.brickSizeX * 0.25;
				}
				else
				{
					%xVal = %brickData.brickSizeX * 0.25;
					%yVal = %brickData.brickSizeY * 0.25;
				}
				%zVal = %brickData.brickSizeZ * 0.1;
				%normal = getWords(%ray, 4, 6);
				%shift = %xVal * getWord(%normal, 0) SPC %yVal * getWord(%normal, 1) SPC %zVal * getWord(%normal, 2);
				if(isObject(%temp)) { %temp.setTransform(vectorAdd(getWords(%ray, 1, 3), %shift)@" 0 0 1 "@((%angle+%brickData.orientationFix+%brickData.floatAngleFix)*$PI/2)); return; }
				else
				{
					%temp = new fxDtsBrick()
					{
						client = %cl;
						angleID = %angle + %brickData.orientationFix + %brickData.floatAngleFix;
						colorID = %cl.currentColor;
						datablock = %brickData;
						position = vectorAdd(getWords(%ray, 1, 3), %shift);
						rotation = "0 0 1 "@(%angle*$PI/2);
					};
					%cl.brickgroup.add(%temp);
					%this.tempbrick = %temp;
				}
			}
			else
			{
				%angle = mFloatLength(mAtan(getWord(%for = %this.getForwardVector(), 0), getWord(%for, 1)) / ($PI / 2), 0) + 1; if(%angle == -1) %angle = 3;
				if(isObject(%temp = %this.tempbrick))
					%brickData = %this.tempbrick.getDatablock();
				else if(!isObject(%cl = %this.client) || %cl.currInv == -1) return;
				else %brickData = %cl.inventory[%cl.currInv];
				if(isObject(%temp = %this.tempbrick)) { %temp.setTransform(%end@" 0 0 1 "@((%angle+%brickData.orientationFix+%brickData.floatAngleFix)*$PI/2)); return; }
				if(!isObject(%cl = %this.client) || %cl.currInv == -1) return;
				%temp = new fxDtsBrick()
				{
					client = %cl;
					angleID = %angle + %brickData.orientationFix + %brickData.floatAngleFix;
					colorID = %cl.currentColor;
					datablock = %brickData;
					position = %end;
					rotation = "0 0 1 "@(%angle*$PI/2);
				};
				%cl.brickgroup.add(%temp);
				%this.tempbrick = %temp;
			}
		}
		else if(%trig == 4 && isObject(%cl = %this.client) && %data.getID() == RealSpacePlayer.getID())
		{
			if(%this.handholdPos !$= "")
			{
				if(!%tog) %this.handholdPos = ""; return;
			}
		}
		else Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	function GameConnection::AutoAdminCheck(%cl, %a, %b, %c)
	{
		%file = new FileObject();
		%file.openForAppend("config/server/RSM Connections.txt");
		%file.writeLine(getDateTime()@": "@%cl.name@" (BL_ID: "@%cl.bl_id@", IP: "@%cl.getRawIP()@") joined the server with RSC r"@%cl.RSCJoinVersion@".");
		%file.delete(); commandToClient(%cl, 'RSC_Handshake');
		%cl.chatMessage($RSM::WelcomeMessage);
		
		//This whole thing needs to be done better, so that all players with 1 BL_ID share 1 battery
		%count = ClientGroup.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%this = ClientGroup.getObject(%i);
			if(%cl.bl_id != %this.bl_id || %cl == %this)
				continue;
			else %cantTalk = 1;
		}
		if(!%cantTalk)
		{
			if($PersistentFuel_[%cl.bl_id] $= "")
			{
				%file = "config/server/RSM/Player Data/"@%blid@".cs";
				if(isFile(%file)) exec(%file);
			}
			if($PersistentFuel_[%cl.bl_id] !$= "")
				%cl.batteryPower = $PersistentPower_[%cl.bl_id];
			else %cl.batteryPower = 100;
		}
		
		//This might be useful later
	//	if(isObject(PersistentPlayers))
	//	{
	//		%count = PersistentPlayers.getCount();
	//		for(%i=0;%i<%count;%i++)
	//			if(PersistentPlayers.getObject(%i).ownerBL_ID == %this.bl_id)
	//				%obj = PersistentPlayers.getObject(%i);
	//	}
		
		return Parent::AutoAdminCheck(%cl);
	}
	
	function GameConnection::createPlayer(%cl, %trans)
	{
		if(isObject(PersistentPlayers))
		{
			%count = PersistentPlayers.getCount();
			for(%i=0;%i<%count;%i++)
				if(PersistentPlayers.getObject(%i).ownerBL_ID == %cl.bl_id)
					%pl = PersistentPlayers.getObject(%i);
		}
		if(isObject(%pl))
		{
			%cl.setControlObject(%pl);
			if(isObject(%this = %pl.client) && %this.getClassName() $= "AIConnection")
			{
				%cl.batteryPower = %this.batteryPower;
				%cl.suitDamage = %this.suitDamage;
				%cl.noSuit = %this.noSuit;
				%this.player = "";
				%this.recycle();
			}
			%pl.client = %cl;
			%cl.player = %pl;
			PersistentPlayers.remove(%pl);
			%pl.lastDispText = "";
			%pl.interactWith = "";
			%pl.interactToken = "";
			%pl.setShapeNameColor("1 1 1");
			commandToClient(%cl, 'PlayGUI_CreateToolHUD', 5);
			for(%i=0;%i<5;%i++)
				messageClient(%cl, 'MsgItemPickup', '', %i, isObject(%tool = %pl.tool[%i]) ? %tool.getID() : -1, 1);
		}
		else
		{
			if(%cl.spawnTransform !$= "")
				%trans = %cl.spawnTransform;
			else
			{
				%ang = getRandom() * 2 * $PI;	//34.1383 = 2048.3 / 60
				%ang = 0;	//BOOKMARK: Temporary fix for people spawning outside oxygenated areas
				%trans = mSin(%ang)*20 SPC mCos(%ang)*20 SPC (34.1383*$RSM::AsteroidDist)@" 0 0 1 "@%ang;
			}
			Parent::createPlayer(%cl, %trans);
			if(isObject(%pl = %cl.player))
			{
				%pl.changeDatablock(RealSpacePlayer);
				if(%cl.spawnVelocity !$= "")
					%pl.setVelocity(%cl.spawnVelocity);
				else %pl.schedule(0, "setVelocity", "0 0 0");
				%pl.setEnergyLevel(getMax(%cl.persistentFuel, %cl.species $= "Robot" ? 3 : 1.5));
				%pl.hasJetpack = 1; %pl.clearTools();
				%pl.tool0 = HammerItem.getID();
				%pl.tool1 = WrenchItem.getID();
				%pl.tool2 = SpacePrintGun.getID();
				%pl.tool3 = RepairWrenchItem.getID();
				%pl.tool4 = SpacePickItem.getID();
				%pl.minOxygen = getRandom(800, 1500) / 100;
				%pl.oxygenLevel = getMax(%pl.minOxygen + 2, %cl.persistentOxygen);
				%pl.lastVel = %pl.getVelocity(); %pl.RSM_StatusLoop(getSimTime());
				for(%i=0;%i<5;%i++)
					messageClient(%cl, 'MsgItemPickup', '', %i, isObject(%tool = %pl.tool[%i]) ? %tool.getID() : -1, 1);
				%pl.setShapeNameDistance(100);
				%pl.species = %cl.species;
				if(%pl.species $= "Zoltan")
					%pl.setPlayerScale(0.822071);
				%pl.setLeakAudio();
			}
		}
		%cl.spawnTransform = ""; %cl.spawnVelocity = "";
	}
	
	function GameConnection::onConnectRequest(%cl, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j)
	{
		%fields = getFieldCount(%j);
		for(%ind=0;%ind<%fields;%ind++)
		{
			%field = getField(%j, %ind);
			if(firstWord(%field) $= "RSC")
				%version = restWords(%field);
		}
		%cl.RSCJoinVersion = %version;
		if(%version < $RSM::RequiredRSCVersion)
			%cl.schedule(0, "delete", "You must have <a:googledrive.com/host/0B4GRSUrNQHt_RVI5R1hNYjhxNGM/Client_RealisticSpace.zip>revision "@$RSM::RequiredRSCVersion@" or later</a> to play on Realistic Space Mod!<br><br>If you have Client_DRPG, delete it - it is poorly written and breaks clients that play nice.");
		Parent::onConnectRequest(%cl, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j);
	}
	
	function GameConnection::onClientEnterGame(%cl)
	{
		%blid = %cl.bl_id;
		%count = ClientGroup.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%test = ClientGroup.getObject(%i);
			if(%test.bl_id == %blid && %test != %cl && %test.hasSpawnedOnce)
				return;
		}
		if($PersistentFuel_[%blid] $= "")
		{
			%file = "config/server/RSM/Player Data/"@%blid@".cs";
			if(isFile(%file)) exec(%file);
		}
		if($PersistentFuel_[%blid] !$= "")
		{
			%cl.persistentFuel = $PersistentFuel_[%blid];
			%cl.persistentOxygen = $PersistentOxygen_[%blid];
			%cl.suitDamage = $PersistentDamage_[%blid];
			%matList = materialList();
			%count = getFieldCount(%matList);
			for(%i=0;%i<%count;%i++)
			{
				%mat = getField(%matList, %i);
				%cl.mat[%mat] = $PersistentMaterial_[%mat, %blid];
				%cl.totalMats += %cl.mat[%mat]; if(%cl.mat[%mat] > 0)
					commandToClient(%cl, 'UpdateMaterial', %cl.mat[%mat], %mat);
			}
			if(%cl.totalMats > %cl.maxMats(0)) %cl.pack = 4;
			%cl.hitsToLevel = $PersistentHitsToLevel_[%blid];
			for(%i=0;%i<10;%i++) %cl.hitWeight[%i, "Pick"] = $PersistentHitWeight[%i, "Pick", %blid];
			%cl.species = $PersistentSpecies_[%blid];
		}
		else
		{
			%cl.persistentFuel = 100;
			%cl.persistentOxygen = 100;
			%cl.suitDamage = 0;
			%cl.hitsToLevel = 100;
			%cl.hitWeight0_Pick = 100;
		}
		if($PersistentLocation_Transform_[%blid] !$= "")
		{
			%timeOffset = DT_getTimeDifference($PersistentData_Timestamp_[%blid], getDateTime());
			%vel = $PersistentLocation_Velocity_[%blid];
			%trans = $PersistentLocation_Transform_[%blid];
			%newPos = vectorAdd(getWords(%trans, 0, 2), vectorScale(%vel, %timeOffset));
			%cl.spawnTransform = %newPos SPC getWords(%trans, 3, 6);
			%cl.spawnVelocity = %vel;
		}
		Parent::onClientEnterGame(%cl);
		if(%cl.hasRSClient && %cl.RSC_Revision < $RSM::LatestRSCVersion)
			%cl.chatMessage("<color:FFFFFF>There's been a client update! Download the <a:googledrive.com/host/0B4GRSUrNQHt_RVI5R1hNYjhxNGM/Client_RealisticSpace.zip>latest revision</a> (r"@$RSM::LatestRSCVersion@")!");
		if(isObject(%pl) && %pl.stunnedTime > 0 && isObject(%cam = %cl.camera))
		{ %cl.setControlObject(%cam); %cam.setMode("CORPSE", %pl); }
		servercmdUpdateBodyParts(%cl, %cl.hat, %cl.accent, %cl.pack, %cl.secondPack, %cl.chest, %cl.hip, %cl.lLeg, %cl.rLeg, %cl.lArm, %cl.rArm, %cl.lHand, %cl.rHand);
		servercmdUpdateBodyColors(%cl, %cl.headColor, %cl.hatColor, %cl.accentColor, %cl.packColor, %cl.secondPackColor, %cl.chestColor, %cl.hipColor,
			%cl.lLegColor, %cl.rLegColor, %cl.lArmColor, %cl.rArmColor, %cl.lHandColor, %cl.rHandColor, %cl.faceName, %cl.decalName);
		
	}
	
	function GameConnection::onClientLeaveGame(%cl)
	{
		if(%cl.hasSpawnedOnce)
		{
			servercmdUntether(%cl);
			%blid = %cl.bl_id;
			%count = ClientGroup.getCount();
			for(%i=0;%i<%count;%i++)
			{
				%test = ClientGroup.getObject(%i);
				if(%test.bl_id == %blid && %test != %cl)
				{ %spawnCl = %test; break; }
			}
			$PersistentFuel_[%blid] = %cl.persistentFuel;
			$PersistentOxygen_[%blid] = %cl.persistentOxygen;
			$PersistentPower_[%blid] = %cl.batteryPower;
			$PersistentDamage_[%blid] = %cl.suitDamage;
			%matList = materialList();
			%count = getFieldCount(%matList);
			for(%i=0;%i<%count;%i++)
			{
				%mat = getField(%matList, %i);
				$PersistentMaterial_[%mat, %blid] = %cl.mat[%mat];
			}
			$PersistentHitsToLevel_[%blid] = %cl.hitsToLevel;
			for(%i=0;%i<10;%i++) $PersistentHitWeight[%i, "Pick", %blid] = %cl.hitWeight[%i, "Pick"];
			$PersistentData_Timestamp_[%blid] = getDateTime();
			$PersistentSpecies_[%blid] = %cl.species;
			
			if(isObject(%pl = %cl.player))
			{
				//Location
			//	$PersistentLocation_Transform_[%blid] = %pl.getTransform();
			//	$PersistentLocation_Velocity_[%blid] = %pl.getVelocity();
				if(!isObject(PersistentPlayers))
					new SimSet(PersistentPlayers);
				PersistentPlayers.add(%pl);
				if(isObject(%temp = %pl.tempbrick))
					%temp.delete();
				%pl.setShapeNameColor("0.4 0.4 0.4");
				%this = CreateAIClient(1);
				%this.batteryPower = %cl.batteryPower;
				%this.suitDamage = %cl.suitDamage;
				%this.noSuit = %cl.noSuit;
				
				//Duplicate the avatar
				%this.hat = %cl.hat;
				%this.accent = %cl.accent;
				%this.pack = %cl.pack;
				%this.secondPack = %cl.secondPack;
				%this.chest = %cl.chest;
				%this.hip = %cl.hip;
				%this.lArm = %cl.lArm;
				%this.lHand = %cl.lHand;
				%this.lLeg = %cl.lLeg;
				%this.rArm = %cl.rArm;
				%this.rHand = %cl.rHand;
				%this.rLeg = %cl.rLeg;
				
				%this.hatColor = %cl.hatColor;
				%this.headColor = %cl.headColor;
				%this.accentColor = %cl.accentColor;
				%this.packColor = %cl.packColor;
				%this.secondPackColor = %cl.secondPackColor;
				%this.chestColor = %cl.chestColor;
				%this.hipColor = %cl.hipColor;
				%this.lArmColor = %cl.lArmColor;
				%this.lHandColor = %cl.lHandColor;
				%this.lLegColor = %cl.lLegColor;
				%this.rArmColor = %cl.rArmColor;
				%this.rHandColor = %cl.rHandColor;
				%this.rLegColor = %cl.rLegColor;
				
				%this.faceName = %cl.faceName;
				%this.decalName = %cl.decalName;
				
				%this.ownerBL_ID = %blid;
				%this.ownerName = %cl.name;
				%pl.ownerBL_ID = %blid;
				%pl.client = %this;
				%this.player = %pl;
				%cl.player = "";
			}
			else
			{
				$PersistentLocation_Transform_[%blid] = "";
				$PersistentLocation_Velocity_[%blid] = "";
			}
			export("$Persistent*_"@%blid, "config/server/RSM/Player Data/"@%blid@".cs");
			if(isObject(%spawnCl)) %spawnCl.schedule(500, "onClientEnterGame");
		}
		Parent::onClientLeaveGame(%cl);
	}
	
	function GameConnection::onDeath(%victim, %object, %killer, %damageType, %damageLoc)
	{
		if(%victim.getClassName() $= "GameConnection")
			Parent::onDeath(%victim, %object, %killer, %damageType, %damageLoc);
		else
		{
			%murder = (isObject(%killer) && %killer != %victim);
			if(%murder)
			{
				%msg = getTaggedString($DeathMessage_Murder[%damageType]);
				%msg = strReplace(%msg, "%1", %victim.ownerName);
				%msg = strReplace(%msg, "%2", %killer.name);
			}
			else
			{
				%msg = getTaggedString($DeathMessage_Suicide[%damageType]);
				%msg = strReplace(%msg, "%1", %victim.ownerName);
			}
			%matList = materialList(); %count = getFieldCount(%matList);
			for(%i=0;%i<%count;%i++) $PersistentMaterial[getField(%matList, %i), %bl_id] = 0;
			messageAll('', %msg); Parent::onDeath(%victim, %object, %killer, $DamageType::Silent, %damageLoc);
			%banManager = BanManagerSO.getID();
			%banManager.addBan(0, 0, %victim.ownerBL_ID, "Autoban: Died in Realistic Space mod.", 15);
			%banManager.saveBans();
			%count = ClientGroup.getCount();
			for(%i=0;%i<%count;%i++)
				if(ClientGroup.getObject(%i).BL_ID == %victim.ownerBL_ID)
					%kick[-1+%kick++] = ClientGroup.getObject(%i);
			for(%i=0;%i<%kick;%i++) %kick[%i].delete("You have been automatically banned for 15 minutes:<br><br>Died in Realistic Space mod.");
			%victim.recycle();
		}
		//make this physically drop materials somehow
		%matList = materialList(); %count = getFieldCount(%matList);
		for(%i=0;%i<%count;%i++) %victim.mat[getField(%matList, %i)] = 0;
		%victim.totalMats = 0; %banManager = BanManagerSO.getID();
		%banManager.addBan(0, %victim, %victim.BL_ID, "Autoban: Died in Realistic Space mod.", 15);
		%banManager.saveBans();
		%count = ClientGroup.getCount();
		for(%i=0;%i<%count;%i++)
			if(ClientGroup.getObject(%i).BL_ID == %victim.BL_ID)
				%kick[-1+%kick++] = ClientGroup.getObject(%i);
		for(%i=0;%i<%kick;%i++) %kick[%i].delete("You have been automatically banned for 15 minutes:<br><br>Died in Realistic Space mod.");
	}
	
	function minigameCanDamage(%a, %b)
	{
		//Do this properly later
		return 1;
	}
	
	function Observer::onTrigger(%data, %this, %trig, %tog)
	{
		if(isObject(%pl = %this.getControllingClient().player) && %pl.getState() !$= "DEAD" && %pl.stunnedTime > 0) return;
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
	
	//Commands we don't want or need.
	function servercmdDropTool(%cl) { return; }
	function servercmdSit(%cl) { return; }
	
	function servercmdSetWrenchData(%cl, %fields)
	{
		if(isObject(%pl = %cl.player))
		{
			for(%i=getFieldCount(%fields)-1;%i>=0;%i--)
			{
				%fieldName = firstWord(getField(%fields, %i));
				%fieldValue = getWord(getField(%fields, %i), 1);
				%rejectedFields = " IDB VDB ";
				if(strPos(%rejectedFields, " "@%fieldName@" ") != -1)
					%fields = removeField(%fields, %i);
				else if(%fieldName $= "VDB")
				{
					if(isObject(%fieldValue) && %cl.wrenchBrick.vehicleLimit !$= "")
						if(%cl.wrenchBrick.vehicleLimit.getID() != %fieldValue.getID())
							return;
				}
			}
		}
		Parent::serverCmdSetWrenchData(%cl, %fields);
	}
	
	function servercmdUpdateBodyColors(%cl, %headColor, %hatColor, %accentColor, %packColor, %secondPackColor, %chestColor, %hipColor,
		%lLegColor, %rLegColor, %lArmColor, %rArmColor, %lHandColor, %rHandColor, %face, %decal)
	{
		if(%cl.species $= "Robot")
		{
			%headColor = vectorScale(%chestColor, 0.8) SPC 1;
			%hatColor = vectorScale(%chestColor, 0.8) SPC 1;
			%accentColor = vectorScale(%chestColor, 0.8) SPC 1;
			%packColor = %chestColor;
			%secondPackColor = vectorScale(%chestColor, 0.9) SPC 1;
			%hipColor = %chestColor;
			%lLegColor = vectorScale(%chestColor, 0.5) SPC 1;
			%rLegColor = vectorScale(%chestColor, 0.5) SPC 1;
			%lArmColor = %chestColor;
			%rArmColor = %chestColor;
			%lHandColor = vectorScale(%chestColor, 0.5) SPC 1;
			%rHandColor = vectorScale(%chestColor, 0.5) SPC 1;
		}
		Parent::servercmdUpdateBodyColors(%cl, %headColor, %hatColor, %accentColor, %packColor, %secondPackColor, %chestColor, %hipColor,
			%lLegColor, %rLegColor, %lArmColor, %rArmColor, %lHandColor, %rHandColor, %face, %decal);
		%cl.lastUpdateBodyColorsTime = 0;
	}
	
	function servercmdUpdateBodyParts(%cl, %hat, %accent, %pack, %secondPack, %chest, %hip, %lLeg, %rLeg, %lArm, %rArm, %lHand, %rHand)
	{
		if(%cl.species $= "Robot")
		{
			%hat = 1;
			%accent = 1;
			%pack = 1;
			%secondPack = 6;
			%chest = 0;
			%hip = 0;
			%lLeg = 0;
			%rLeg = 0;
			%lArm = 0;
			%rArm = 0;
			%lHand = 0;
			%rHand = 0;
		}
		else if(%cl.totalMats > %cl.maxMats(0)) %pack = 4;
		Parent::servercmdUpdateBodyParts(%cl, %hat, %accent, %pack, %secondPack, %chest, %hip, %lLeg, %rLeg, %lArm, %rArm, %lHand, %rHand);
		%cl.lastUpdateBodyPartsTime = 0;
	}
	
	function servercmdCreateMinigame() { }
	function servercmdStartTalking(%cl) { %cl.autoRejectTethers = 1; Parent::servercmdStartTalking(%cl); }
	function servercmdStopTalking(%cl) { %cl.autoRejectTethers = 0; Parent::servercmdStopTalking(%cl); }
	function servercmdSuicide(%cl) { if($Pref::Space::Testing) Parent::servercmdSuicide(%cl); }
	function servercmdLight(%cl) { if(%cl.batteryPower != 0) Parent::servercmdLight(%cl); }
	
	function onExit() { export("$Persistent*", "config/server/SpaceRP.cs"); Parent::onExit(); }
};
activatePackage("RealSpace");

function servercmdRSC_Handshake(%cl, %revision)
{ %cl.hasRSClient = 1; %cl.RSC_Revision = %revision; %cl.RSCJoinRevision = ""; }

function Player::RSM_StatusLoop(%pl, %last)
{
	cancel(%pl.StatusLoop);
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%frightGoal = getMax(50 - %pl.oxygenLevel, 0) / 1.5;
	%frightDiff = %frightGoal - %pl.frightLevel;
	if(%frightDiff > 0)
	{
		%e = 2.7182818285;
		%finalDiff = %frightDiff * mPow(%e, -0.2 * %time);
		%pl.frightLevel = %frightGoal - %finalDiff;
	}
	else %pl.frightLevel = getMax(%pl.frightLevel - (%time / 3), 0);
	if(isObject(%cl = %pl.client))
	{
		if(%pl.species !$= "Robot")
		{
			%heartVolume = mClamp(mFloor(%pl.frightLevel / 2.5), 0, 8);
			if(%heartVolume != 0)
			{
				%heartRate = 75 + %pl.frightLevel * 2;
				%heartTime = vectorDist(%pl.lastHeartbeat, %now) / 1000;
				if(%heartTime >= 60 / %heartRate)
				{
					%cl.play2D(("Heartbeat"@(%heartVolume + 1)).getID());
					%pl.lastHeartbeat = %now;
				}
			}
			%oxyLevel = %pl.oxygenLevel;
			if(%cl.hat != 1 || %cl.accent != 1) { %rate = 5; %noSuit = 1; }
			else
			{
				if(%cl.pack != 6) %rate = 0.08333333;
				else %rate = 0.01388888;
				if(isObject(%buddy = %pl.TetherBuddy) && %buddy.oxygenLevel > %oxyLevel &&
					isObject(%buddyCl = %buddy.client) && %buddyCl.hat == 1 && %buddyCl.accent == 1)
				{
					%maxOxyTransfer = %time * 0.1;
					if(%buddy.oxygenLevel > (%oxyLevel + %maxOxyTransfer * 2))
					{ %buddy.oxygenLevel -= %maxOxyTransfer; %oxyLevel += %maxOxyTransfer; }
					else { %oxyLevel = (%buddy.oxygenLevel = (%buddy.oxygenLevel + %oxyLevel) / 2); }
				}
			}
			if(%noSuit != %cl.noSuit) { %cl.noSuit = %noSuit; %pl.setLeakAudio(); }
			//initContainerRadiusSearch(%pl.getHackPosition(), 0.05, $Typemasks::fxBrickAlwaysObjectType);
			if(isObject(StationCores))
			{
				%cores = StationCores.getCount();
				for(%i=0;%i<%cores;%i++)
				{
					%core = StationCores.getObject(%i);
					if(vectorDist(%pl.getHackPosition(), %core.getPosition()) <= 100 &&
						%core.getGasPressure(%pl.getEyePoint(), 0) >= 2)
						{ %pl.breathing = getSimTime(); break; }
				}
			}
			if(vectorDist(%pl.breathing, %now) < 1000) %rate *= -1;
			if($Pref::Space::Testing && %rate > 0) %rate *= -1;
			if(%pl.species $= "Zoltan") %mult = 2;
			else %mult = 1;
			if(%rate > 0) %rate *= %mult;
			if(%cl.hat == 1 && %cl.accent == 1) %rate += %cl.suitDamage;
			else if(!$RSM::Sandbox && %rate > 0 && !isEventPending(%pl.endDV))
			{
				%dirList = "FBLRUD";
				for(%i=0;%i<6;%i++) if(isEventPending(%pl.JetpackLoop[getSubStr(%dirList, %i, 1)])) %noPrint = 1;
				if(!%noPrint) %cl.centerPrint("<br><br>\c6PUT A HELMET ON YOUR AVATAR!<br><bitmap:base/client/ui/avatarIcons/hat/helmet>", 1);
				cancel(%pl.suffocating); %pl.suffocating = schedule(100, 0, "doNothing");
			}
			if(%rate < 0 && (%cl.hat != 1 || %cl.accent != 1)) %cl.batteryPower = getMin(%cl.batteryPower + 0.111111 * %time, 100);
			if($RSM::Sandbox) %rate = -10;
			%pl.oxygenLevel = getMax(getMin(%oxyLevel - (%time * %rate), 100), 0);
			if(%pl.oxygenLevel < 50 && %cl.hat == 1 && %cl.accent == 1 && %cl.matOxygen >= 0.1)
			{
				%pl.oxygenLevel += 2; %cl.matOxygen -= 0.1; %cl.totalMats -= 0.1;
				if(%cl.hasRSClient) commandToClient(%cl, 'UpdateMaterial', mFloatLength(%cl.matOxygen, 3), "Oxygen");
			}
		}
		else
		{
			if(isObject(StationCores))
			{
				%cores = StationCores.getCount();
				for(%i=0;%i<%cores;%i++)
				{
					%core = StationCores.getObject(%i);
					if(vectorDist(%pl.getHackPosition(), %core.getPosition()) <= 100 &&
						%core.getGasPressure(%pl.getEyePoint(), 0) >= 2)
						{
							%pl.oxygenLevel = getMin(%pl.oxygenLevel + %time * 0.25, 100);
							%cl.batteryPower = getMin(%cl.batteryPower + %time * 0.111111, 100);
						}
				}
			}
			if(isObject(%buddy = %pl.TetherBuddy) && %buddy.species !$= "Robot")
			{
				if(isObject(%buddyCl = %buddy.client) && %buddyCl.hat == 1 && %buddyCl.accent == 1)
				{
					%maxOxyTransfer = getMin(%time * 0.1, getMin(100 - %buddy.oxygenLevel, %pl.oxygenLevel / 5));
					%buddy.oxygenLevel += %maxOxyTransfer; %pl.oxygenLevel -= %maxOxyTransfer;
				}
			}
		}
	}
	if(%pl.handholdPos !$= "")
	{
		%holdDir = vectorNormalize(vectorSub(%pl.handholdPos, %pl.getHackPosition()));
		%holdDot = vectorDot(%holdVel = %pl.getVelocity(), %holdDir);
		%holdSpeed = vectorLen(%holdVel) * %holdDot;
		if(%holdDot < 0 && %holdSpeed < -2)
		{
			%axis0 = vectorNormalize(vectorCross(%holdDir, "0 0 1"));
			%axis1 = vectorNormalize(vectorCross(%holdDir, %axis0));
			%rel = Solve3DMatrix(%holdVel, %holdDir, %axis0, %axis1);
			%pl.setVelocity(vectorAdd(vectorScale(%axis0, getWord(%rel, 1)), vectorScale(%axis1, getWord(%rel, 2))));
			%pl.lastVel = %pl.getVelocity();
		}
		if(%holdSpeed < 0.5) %pl.addVelocity(vectorScale(%holdDir, %time));
	}
	%dispOxy = mFloatLength(%pl.oxygenLevel, 1);
	%dispFuel = mFloatLength(%pl.getEnergyLevel(), 1);
	%oxyTag = getSlidingColorTag(%dispOxy, "100 00FF00\t50 FFFF00\t0 FF0000");
	%fuelTag = getSlidingColorTag(%dispFuel, "100 00FF00\t50 FFFF00\t0 FF0000");
	if(isObject(%veh = %pl.getObjectMount()))
	{ %for = %veh.getForwardVector(); %up = %pl.getUpVector(); }
	else { %for = %pl.getForwardVector(); %up = "0 0 1"; }
	%right = vectorCross(%for, %up);
	%vel = %pl.getVelocity();
	if(%pl.lastVel $= "") %pl.lastVel = %vel;
	if(vectorDist(%vel, %pl.lastVel) >= 0.5)
	{
		%normal = vectorSub(%pl.lastVel, %vel);
		%mask = $Typemasks::PlayerObjectType | $Typemasks::fxBrickAlwaysObjectType;
		initContainerRadiusSearch(%hackPos = %pl.getHackPosition(), 3, %mask);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%pl == %obj) continue;
			if(%obj.getType() & $Typemasks::fxBrickAlwaysObjectType)
			{ if(%obj.isColliding()) %dontRetain = 1; continue; }
			else if((%dot = vectorDot(vectorNormalize(vectorSub(%hackPos, %obj.getHackPosition())), %normal)) <= %best)
			{ %best = %dot; %hitPlayer = %obj; }
		}
		if(!%dontRetain && isObject(%hitPlayer))
		{
			%hitVel = %hitPlayer.getVelocity();
			%normX = mAbs(getWord(%normal, 0));
			%normY = mAbs(getWord(%normal, 1));
			%normZ = mAbs(getWord(%normal, 2));
			if(%normX > %normY && %normX > %normZ) { %diff = getWord(%pl.lastVel, 0) - getWord(%hitVel, 0); %velChange = %diff@" 0 0"; }
			else if(%normY > %normX && %normY > %normZ) { %diff = getWord(%pl.lastVel, 1) - getWord(%hitVel, 1); %velChange = "0 "@%diff@" 0"; }
			else if(%normZ > %normX && %normZ > %normY) { %diff = getWord(%pl.lastVel, 2) - getWord(%hitVel, 2); %velChange = "0 0 "@%diff; }
			%hitPlayer.addVelocity(%velChange);
			%hitPlayer.lastVel = vectorAdd(%hitPlayer.lastVel, %velChange);
			%pl.setVelocity(vectorSub(%pl.lastVel, %velChange));
			%vel = %pl.getVelocity(); %normal = %velChange;
		}
		if(!$RSM::Sandbox && (vectorLen(%normal) > 5))
		{
			if(%pl.species $= "Robot") %pl.addStunTime(getMax((vectorLen(%normal) - 10) * 2, 0));
			else if(isObject(%cl) && %cl.hat == 1 && %cl.accent == 1 && !$RSM::NoSuitDamage)
			{
				%cl.suitDamage = getMin(%cl.suitDamage + (vectorLen(%normal) - 5) * 0.005, 1); %pl.setLeakAudio();
				if(isObject(%hitPlayer) && isObject(%hitCl = %hitPlayer.client) && %hitCl.hat == 1 && %hitCl.accent == 1)
				{ %hitCl.suitDamage = getMin(%hitCl.suitDamage + (vectorLen(%normal) - 5) * 0.005, 1); %hitPlayer.setLeakAudio(); }
			}
		}
	}
	%pl.lastVel = %vel;
	if(isObject(%buddy = %pl.tetherBuddy))
	{
	//	%massA = %buddy.getMass(); %massB = %pl.getMass();
	//	%velA = vectorScale(%buddy.getVelocity(), %massA);
	//	%velB = vectorScale(%vel, %massB);
	//	%vel = vectorScale(vectorAdd(%velA, %velB), 1 / (%massA + %massB));
		%vel = vectorScale(vectorAdd(%buddy.getVelocity(), %vel), 0.5);
	}
	if(isObject(%targ = %pl.target)) %vel = vectorSub(%vel, %targ.getVelocity());
	%relVel = Solve3DMatrix(vectorScale(%vel, 2), %for, %right, %up);
	for(%i=0;%i<3;%i++)
	{
		%val = mFloatLength(getWord(%relVel, %i), 1);
		%relVel = setWord(%relVel, %i, %val $= "-0.0" ? "0.0" : %val);
	}
	%batRate = 0.00333333;
	if(isObject(%pl.light)) %batRate += 0.0966667;
	if(%pl.species $= "Zoltan") %batRate -= 0.00222222;
	if($RSM::Sandbox) %batRate = -10;
	%cl.batteryPower = getMax(getMin(%cl.batteryPower - %time / 60 * %batRate, 100), 0);
	%dispText = %dispOxy SPC %dispFuel SPC %cl.batteryPower;
	if(%dispText !$= %pl.lastDispText && isObject(%cl = %pl.client))
	{
		%newArray = new ScriptObject() { class = "ByteArraySO"; };
		%data0 = ToFloat16(%dispOxy / 100);
		%data1 = ToFloat16(%dispFuel / 100);
		%data2 = ToFloat16(%cl.batteryPower / 100);
		for(%i=0;%i<3;%i++)
		{
			%newArray.byte[%i * 2] = %data[%i] >> 8;
			%newArray.byte[%i * 2 + 1] = %data[%i] & 255;
		}
		%newArray.bytes = 6;
		commandToClient(%cl, 'RSC_UpdateMainHUD', %newArray.ToBase64());
		%newArray.delete();
		if(%pl.species !$= "Robot") commandToClient(%cl, 'setVignette', 0, "0.5 0.5 0.5 "@getMax(1 - %dispOxy / 50, 0));
		%pl.lastDispText = %dispText;
	}
	if(%cl.batteryPower <= 0 && isObject(%light = %pl.light)) { %pl.light = ""; %light.delete(); }
	%cl.persistentOxygen = %pl.oxygenLevel;
	if(%pl.oxygenLevel < %pl.minOxygen && %pl.species !$= "Robot")
	{
		if(isObject(%cl = %pl.client))
			%cl.persistentOxygen = getMin(%cl.persistentOxygen, 10);
		%pl.kill(); return;
	}
	if(%pl.species !$= "Robot")
	{
		%left = 10 - (%pl.oxygenLevel - %pl.minOxygen);
		%pl.setDamageFlash(%left / 20);
	}
	%eye = %pl.getEyePoint();
	%dir = %pl.getEyeVector();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::VehicleObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 20)), %mask, %pl);
	if(isObject(%hit = firstWord(%ray)) && %hit != %pl.interactWith)
	{
		if(%hit.getType() & $Typemasks::fxBrickAlwaysObjectType)
		{
			%dist = vectorDist(%pl.getHackPosition(), %hit.getPosition());
			if(%dist <= 8)
			{
				%dbName = %hit.getDatablock().getName();
				if(%dbName $= "brickFabricatorData")
				{
					if(getTrustLevel(%cl, %hit.getGroup()) >= %hit.getVar("TrustLevel"))
					{
						%pl.interactWith = %hit;
						%pl.interactToken = RSM_InteractToken();
						commandToClient(%cl, 'RSC_Interact', "AAAC", %pl.interactToken);
					}
				}
				else if(%dbName $= "brickFabricatorCoverData" && %hit.mainFabber != %pl.interactWith)
				{
					if(getTrustLevel(%cl, %hit.mainFabber.getGroup()) >= %hit.mainFabber.getVar("TrustLevel"))
					{
						%pl.interactWith = %hit.mainFabber;
						%pl.interactToken = RSM_InteractToken();
						commandToClient(%cl, 'RSC_Interact', "AAAC", %pl.interactToken);
					}
				}
				else if(%dbName $= "brickStasisPodData")
				{
					%pl.interactWith = %hit;
					%pl.interactToken = RSM_InteractToken();
					commandToClient(%cl, 'RSC_Interact', "AAAD", %pl.interactToken);
				}
				else if(%dbName $= "brickStationCoreData")
				{
					%pl.interactWith = %hit;
					%pl.interactToken = RSM_InteractToken();
					commandToClient(%cl, 'RSC_Interact', "AAAB", %pl.interactToken, %hit.stationName);
				}
			}
		}
	}
	%obj = %pl.interactWith;
	if(isObject(%obj))
	{
		if(%obj.getType() & $Typemasks::fxBrickAlwaysObjectType)
		{
			%dist = vectorDist(%pl.getHackPosition(), %obj.getPosition());
			if(%dist > 8)
			{
				%pl.interactWith = "";
				%pl.interactToken = "";
				commandToClient(%cl, 'RSC_Interact');
			}
		}
	}
	%pl.StatusLoop = %pl.schedule(16, "RSM_StatusLoop", %now);
}

function servercmdAcceptLastTether(%cl)
{
	if(isObject(%this = %cl.LastTetherer) && isObject(%plA = %cl.player) && isObject(%plB = %this.player))
	{
		if(vectorDist(%plA.getHackPosition(), %plB.getHackPosition()) > $TetherLength)
		{
			%cl.chatMessage("\c6Tether failed: \c2"@%this.name@"\c6 is too far away.");
			%this.chatMessage("\c6Tether failed: \c2"@%cl.name@"\c6 is too far away.");
			return;
		}
		if(isObject(%buddy = %plA.TetherBuddy))
		{ %buddy.TetherBuddy = ""; if(isObject(%buddy.client)) %buddy.client.chatMessage("\c6Untethered from \c2"@%cl.name@"\c6."); }
		%cl.chatMessage("\c6You have been tethered to \c2"@%this.name@"\c6.");
		%this.chatMessage("\c6You have been tethered to \c2"@%cl.name@"\c6.");
		cancel(%plA.TetherLoop); cancel(%plB.TetherLoop);
		%plA.TetherBuddy = %plB; %plB.TetherBuddy = %plA;
		TetherLoop(%plA, %plB, getSimTime());
	}
}

function servercmdUntether(%cl)
{
	if(isObject(%plA = %cl.player) && isObject(%plA.TetherBuddy))
	{
		cancel(%plA.TetherLoop);
		%plB = %plA.TetherBuddy; %this = %plB.client;
		%cl.chatMessage("\c6Untethered from \c2"@((%name=%this.name)!$=""?%name:"Bot")@"\c6.");
		if(isObject(%this)) %this.chatMessage("\c6Untethered from \c2"@%cl.name@"\c6.");
		%plA.TetherBuddy = ""; %plB.TetherBuddy = "";
	}
}

function servercmdDisappear(%cl, %rad, %time)
{
	if(%cl.bl_id != 11239 || !isObject(%pl = %cl.player)) return;
	initContainerRadiusSearch(%pl.getHackPosition(), %rad / 2, $Typemasks::fxBrickAlwaysObjectType);
	while(isObject(%brick = containerSearchNext()))
	{
		%brick.schedule(%time * 1000, "setColliding", %brick.isColliding());
		%brick.schedule(%time * 1000, "setRaycasting", %brick.isRaycasting());
		%brick.schedule(%time * 1000, "setRendering", %brick.isRendering());
		%brick.setColliding(0); %brick.setRaycasting(0); %brick.setRendering(0);
	}
}

function Player::dragOOGer(%pl, %obj, %last)
{
	cancel(%pl.draggingLoop);
	if(isObject(%cl = %obj.client) && %cl.getClassName() $= "GameConnection") return;
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%targ = vectorAdd(%pl.getEyePoint(), vectorScale(%pl.getEyeVector(), 3));
	%dir = vectorSub(%targ, %obj.getHackPosition());
	%obj.addVelocity(vectorScale(%dir, %time));
	%pl.draggingLoop = %pl.schedule(16, "dragOOGer", %obj, %now);
}

function servercmdUseJetpack(%cl, %dir, %on)
{
	if(%cl.choosingSpecies || !isObject(%pl = %cl.player) || %pl.getDatablock().getID() != RealSpacePlayer.getID() || !%pl.hasJetpack || %pl.getEnergyLevel() <= 0) return;
	if(%on) { %pl.jetForce[%dir] = getMax(getMin(%on, 1), 0.01); %pl.UseJetpack(getSimTime(), %dir); %pl.handholdPos = ""; }
	else { cancel(%pl.JetpackLoop[%dir]); %pl.JetParticleTime[%dir] = 0; %pl.endDV = %pl.schedule(2000, "EndManeuver"); }
}

function Player::UseJetpack(%pl, %last, %dir)
{
	if(!isObject(%pl) || !isObject(%cl = %pl.client) || %pl.stunnedTime > 0) return;
	cancel(%pl.JetpackLoop[%dir]); cancel(%pl.endDV);
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	%pl.JetParticleTime[%dir] += %time;
	%time *= (%power = %pl.jetForce[%dir]);
	if(!$RSM::Sandbox)
	{ if(%time > (%energy = %pl.getEnergyLevel())) %time = %energy; }
	%eye = %pl.getEyeVector(); %forward = %pl.getForwardVector();
	%fore = getWords(vectorScale(%forward, vectorLen(getWords(%eye, 0, 1))), 0, 1) SPC getWord(%eye, 2);
	if(mAbs(getWord(%fore, 2)) >= 0.9995)
	{
		%up = vectorNormalize(vectorScale(%forward, -getWord(%fore, 2)));
		%right = vectorNormalize(vectorCross(%fore, %up));
	}
	else { %right = vectorNormalize(vectorCross(%fore, "0 0 1")); %up = vectorNormalize(vectorCross(%right, %fore)); }
	%force = %time * 100; %force /= ($RSM::Sandbox ? 35 : %pl.getMass());
	switch$(%dir)
	{
		case "F": %pl.addVelocity(vectorScale(%velDir = %fore, %force));
		case "B": %pl.addVelocity(vectorScale(%velDir = vectorScale(%fore, -1), %force));
		case "R": %pl.addVelocity(vectorScale(%velDir = %right, %force));
		case "L": %pl.addVelocity(vectorScale(%velDir = vectorScale(%right, -1), %force));
		case "U": %pl.addVelocity(vectorScale(%velDir = %up, %force));
		case "D": %pl.addVelocity(vectorScale(%velDir = vectorScale(%up, -1), %force));
		default: return;
	}
	%cl.batteryPower = getMax(getMin(%cl.batteryPower + (%time * %power * 1.66666), 100), 0);
	%pl.deltaV += %force; %dispDV = mFloatLength(%pl.deltaV * 2, 1);
	if(%pl.JetParticleTime[%dir] >= 0.05)
	{
		%pl.JetParticleTime[%dir] -= mFloor(%pl.JetParticleTime[%dir] * 20) / 20;
		%vel = vectorAdd(%pl.getVelocity(), vectorScale(%velDir, -7));
		%pl.SpawnJetParticle(vectorAdd(vectorScale(%fore, -0.5), %pl.getMuzzlePoint(2)), %vel, %power);
	}
	if(%dispDV !$= %pl.lastDispDV && isObject(%cl))
	{
		if(isEventPending(%pl.suffocating) && (%cl.hat != 1 || %cl.accent != 1)) %helmet = "\c6PUT A HELMET ON YOUR AVATAR!<br><bitmap:base/client/ui/avatarIcons/hat/helmet>";
		else %helmet = "<br>";
		%cl.centerPrint("<br><br>"@%helmet@"<br><br><br><br>\c6Executing a maneuver of \c3"@%dispDV@"\c6 studs per second.", 5);
		%cl.persistentFuel = %energy - %time; %pl.lastDispDV = %dispDV;
	}
	if(%pl.species $= "Robot") %time *= 2;	//Robots only have half as much fuel.
	if(!$RSM::Sandbox) %pl.setEnergyLevel($Pref::Space::Testing ? 100 : %energy - %time);
	if(%pl.getEnergyLevel() <= 0) %pl.endDV = %pl.schedule(2000, "EndManeuver");
	else %pl.JetpackLoop[%dir] = %pl.schedule(16, "UseJetpack", %now, %dir);
	%cl.persistentFuel = %pl.getEnergyLevel();
}

function Player::SpawnJetParticle(%pl, %pos, %vel, %scale)
{
	if($RSM::Sandbox) return;
	%scale = getMax(%scale, 0.2);
	return new Projectile()
	{
		scale = %scale SPC %scale SPC %scale;
		datablock = RSMJetProjectile;
		initialPosition = %pos;
		initialVelocity = %vel;
		client = %pl.client;
	};
}

function Player::EndManeuver(%pl)
{
	%dispDV = mFloatLength(%pl.deltaV * 2, 1); %pl.deltaV = 0;
	%pl.lastDispDV = ""; if(isObject(%cl = %pl.client))
	{
		if(isEventPending(%pl.suffocating) && (%cl.hat != 1 || %cl.accent != 1)) %helmet = "\c6PUT A HELMET ON YOUR AVATAR!<br><bitmap:base/client/ui/avatarIcons/hat/helmet>";
		else %helmet = "<br>";
		%cl.centerPrint("<br><br>"@%helmet@"<br><br><br><br>\c2Executed a maneuver of \c3"@%dispDV@"\c2 studs per second.", 2);
	}
}

function doNothing() { }	//Used for timeout schedules

datablock PlayerData(RealSpacePlayer : PlayerStandardArmor)
{
	canJet = 0;
	uiName = "";
	runForce = 0;
	jumpForce = 0;
	airControl = 0;
	rechargeRate = 0;
	runSurfaceAngle = 0;
	firstPersonOnly = 1;
	jumpSurfaceAngle = 0;
};

datablock ParticleData(RepairWrenchExplosionParticle : WrenchExplosionParticle)
{ colors[0] = "0 1 0 1"; colors[1] = "0 0.3 0 1"; };

datablock ParticleData(RepairWrenchSparkParticle : WrenchSparkParticle)
{ colors[0] = "0 0.2 0 1"; colors[1] = "0 0 0 1"; };

datablock ParticleEmitterData(RepairWrenchExplosionEmitter : WrenchExplosionEmitter)
{ particles = RepairWrenchExplosionParticle; uiName = ""; };

datablock ParticleEmitterData(RepairWrenchSparkEmitter : WrenchSparkEmitter)
{ particles = RepairWrenchSparkParticle; uiName = ""; };

datablock ExplosionData(RepairWrenchExplosion : WrenchExplosion)
{
	lightStartColor = "0 1 0 1";
	emitter[0] = RepairWrenchExplosionEmitter;
	emitter[1] = RepairWrenchSparkEmitter;
};

datablock ProjectileData(RepairWrenchProjectile : WrenchProjectile)
{
	explodeOnPlayerImpact = 1;
	explosion = RepairWrenchExplosion;
	lightColor = "0 1 0 1";
};

datablock ItemData(RepairWrenchItem : WrenchItem)
{
	colorShiftColor = "0 1 0 1";
	image = RepairWrenchImage;
	uiName = "Repairer";
};

datablock ShapeBaseImageData(RepairWrenchImage : WrenchImage)
{
	colorShiftColor = "0 1 0 1";
	item = RepairWrenchItem;
	projectile = RepairWrenchProjectile;
	
	stateAllowImageChange[1] = 1;
	stateAllowImageChange[2] = 0;
	stateAllowImageChange[3] = 0;
	stateAllowImageChange[4] = 0;
	stateAllowImageChange[5] = 0;
	stateTransitionOnTriggerDown[4] = "PreFire";
};

function RepairWrenchImage::onFire(%image, %obj, %slot)
{
	%obj.playThread(2, "Wrench");
	%eye = %obj.getEyePoint();
	%dir = %obj.getEyeVector();
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::TerrainObjectType | $Typemasks::VehicleObjectType;
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 4)), %mask, %obj);
	if(isObject(%hit = firstWord(%ray)))
	{
		if(%hit.getType() & $Typemasks::PlayerObjectType)
		{
			serverPlay3DSpace(WrenchHitSound, getWords(%ray, 1, 3));
			if(isObject(%cl = %obj.client) && isObject(%this = %hit.client))
			{
				%name = %this.name $= "" ? %this.ownerName $= "" ? "This bot" : %this.ownerName : %this.name;
				if(%hit.species $= "Robot") %cl.chatMessage("\c6"@%name@" is a robot and doesn't require suit repairs.");
				else if(%this.hat != 1 || %this.accent != 1) %cl.chatMessage("\c6"@%name@" isn't wearing a suit.");
				else if(%this.suitDamage == 0) %cl.chatMessage("\c6"@%name@"'s suit is undamaged.");
				else if(%this.suitDamage <= 0.025) { %this.suitDamage = 0; %cl.chatMessage("\c6Fully repaired "@%name@"'s suit."); %hit.setLeakAudio(); }
				else { %this.suitDamage -= 0.025; %cl.chatMessage("\c6Partially repaired "@%name@"'s suit."); %hit.setLeakAudio(); }
			}
		}
		else serverPlay3DSpace(WrenchMissSound, getWords(%ray, 1, 3));
		new Projectile()
		{
			datablock = RepairWrenchProjectile;
			initialPosition = vectorAdd(getWords(%ray, 1, 3), vectorScale(getWords(%ray, 4, 6), 0.05));
			initialVelocity = vectorScale(getWords(%ray, 4, 6), -100);
		};
	}
}

//function WrenchImage::onFire(%image, %obj, %slot)
//{
//	%mask = $Typemasks::fxBrickAlwaysObjectType;
//	%eDir = %obj.getEyeVector(); %len = vectorLen(getWords(%eDir, 0, 1)); %up = getWord(%eDir, 2);
//	%dir = getWords(vectorScale(%obj.getForwardVector(), %len), 0, 1) SPC %up;
//	%ray = containerRaycast(%eye = %obj.getEyePoint(), vectorAdd(%eye, vectorScale(%dir, 8)), %mask, %obj);
//	if(!isObject(%hit = firstWord(%ray))) return;
//	WrenchImage.onHitObject(%obj, 0, %hit, getWords(%ray, 1, 3), getWords(%ray, 4, 6));
//}

//remove the package when the replacement works fully
package overwrite1
{
	function WrenchImage::onHitObject(%image, %obj, %zero, %hit, %hitPos, %normal)
	{
		if(!isObject(%cl = %obj.client))
		{ serverPlay3D(WrenchMissSound, %hitPos); return; }
		%trust = getTrustLevel(%obj, %hit) >= $TrustLevel::Wrench;
		if(%trust || (%cl.isAdmin || %cl.isSuperAdmin))
		{
			%hit.sendWrenchData(%obj.client);
			%group = %hit.getGroup();
			//I'm sure the second and third arguments aren't always inverses of each other
			commandToClient(%cl, 'OpenWrenchDlg', %group.name@" - (BL_ID: "@%group.bl_id@")", %trust, !%trust, !%trust);
			%cl.wrenchBrick = %hit; serverPlay3DSpace(WrenchHitSound, %hitPos);
		}
		else serverPlay3D(WrenchMissSound, %hitPos);
		new Projectile()
		{
			datablock = WrenchProjectile;
			initialPosition = vectorAdd(%hitPos, vectorScale(%normal, 0.05));
			initialVelocity = vectorScale(%normal, -100);
		};
	//	Parent::onHitObject(%image, %obj, %zero, %hit, %hitPos, %normal);
	}
};
activatePackage("overwrite1");

datablock ItemData(SpacePrintGun : PrintGun)
{ image = SpacePrintGunImage; };

datablock ShapeBaseImageData(SpacePrintGunImage : PrintGunImage)
{ item = SpacePrintGun; stateSound[2] = ""; };

//Figure out these variables at some point
function SpacePrintGunImage::onHitObject(%image, %obj, %zero, %hit, %hitPos, %normal)
{ return PrintGunImage.onHitObject(%obj, %zero, %hit, %hitPos, %normal); }

function SpacePrintGunImage::onFire(%image, %obj, %slot)
{
	serverPlay3DSpace(PrintFireSound, %obj.getMuzzlePoint(0));
	PrintGunImage::onFire(%image, %obj, %slot);
}

//Load the libraries first
exec("./Libraries/AI Recycler.cs");
exec("./Libraries/Brick Vars.cs");
exec("./Libraries/ByteArraySO.cs");
exec("./Libraries/DateTime.cs");
exec("./Libraries/Float16.cs");

exec("./Libraries/Misc.cs");

//Reorder these at some point
exec("./Airjets.cs");
exec("./Asteroids.cs");
exec("./Bad Events.cs");
exec("./Building.cs");
exec("./Color Tags.cs");
exec("./Commit.cs");
exec("./Fabricator.cs");
exec("./Fright.cs");
exec("./Interaction.cs");
exec("./Mining.cs");
exec("./Oxygen.cs");
exec("./Player Stuff.cs");
exec("./Radio Chat.cs");
exec("./Saving.cs");
exec("./Skills.cs");
exec("./Solar Flares.cs");
exec("./Sounds.cs");
exec("./Species.cs");
exec("./Stunning.cs");
exec("./Suncycle.cs");
exec("./Testing.cs");
exec("./Tether.cs");
exec("./Trading.cs");
exec("./Turrets.cs");

exec("./Arc Welder/Arc Welder.cs");
exec("./Bricks/Bricks.cs");
exec("./Models/Models.cs");
exec("./Pickaxe/Pickaxe.cs");
exec("./Spray Can/Spray Can.cs");
exec("./Weapons/Weapons.cs");

if(!$RSM_Loaded)
{
	$RSM_Loaded = 1;
	if(isFile("config/server/RSM Save.rss")) schedule(1000, 0, "RSM_LoadFromFile", "config/server/RSM Save.rss");
	else schedule(1000, 0, "RSM_LoadFromFile", "Add-Ons/Gamemode_Space_Mod/Spawn Station.rss");
}