function fxDtsBrick::mineAsteroid(%brick, %cl, %hitPos)
{
	if(!isObject(%cl)) return;
	if(%cl.totalMats > %cl.maxMats(%cl.pack == 4) - 1) { %cl.centerPrint("\c0Can't mine that; your pack is full!", 3); return; }
	%rel = vectorSub(%hitPos, %pos = %brick.getPosition());
	if(%brick.healthOf[%rel] $= "")
	{
		%value = (getRandom() - 0.5) * 1.81818;
		%base = -(0.1 * %value) / (%value * %value - 1);
		%part = (0.1 * %value * %value) / (%value * %value - 1);
		if(%value > 0) %final = %base - %part;
		else %final = %base + %part;
		%final = mFloatLength(mClampF((%final + 1) * 100, 0, 200), 0);
		%brick.healthOf[%rel] = %final;
		%brick.origHealth[%rel] = %brick.healthOf[%rel];
		%mats = (getRandom(0, 999) ? commonMaterials() : rareMaterials());
		%mat = getField(%mats, getRandom(0, getFieldCount(%mats) - 1));
		%brick.material[%rel] = %mat;
	}
	%brick.healthOf[%rel] -= %cl.getSkillChance("Pick");
	%cl.hitsToLevel--;
	if(%cl.hitsToLevel <= 0)
	{
		%cl.hitsToLevel = 100;
		%cl.giveSkillExp("Pick", 100);
	}
	if(%brick.healthOf[%rel] <= 0)
	{
		%data = %brick.getDatablock();
		switch$(%data.getName())
		{
			case "brick2xCubeData": %cl.giveResources(%brick); %brick.delete(); return;
			case "brick4xCubeData": %shift = 1; %newData = brick2xCubeData.getID();
			case "brick8xCubeData": %shift = 2; %newData = brick4xCubeData.getID();
			case "brick16xCubeData": %shift = 4; %newData = brick8xCubeData.getID();
		}
		%data = new ScriptObject();
		for(%z=-%shift+0.5;%z<=%shift;%z++)
			for(%y=-%shift+0.5;%y<=%shift;%y++)
				for(%x=-%shift+0.5;%x<=%shift;%x++)
				{
					%rel = %x SPC %y SPC %z;
					%data.healthOf[%rel] = %brick.healthOf[%rel];
					%data.origHealth[%rel] = %brick.origHealth[%rel];
					%data.material[%rel] = %brick.material[%rel];
				}
		%asteroid = %brick.asteroidGroup; %brick.delete(); %shift /= 2;
		schedule(0, 0, "createBrokenBlocks", %newData, %pos, %shift, %data, %asteroid, %cl, %hitPos);
	}
	else
	{
		%ascii = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
		//Make characters get inserted or removed at low skill levels, instead of just encasing with spaces
		%chance = mPow(1-%cl.getSkillRating("Pick",100),2); %mat = strReplace(applyDistortion("   "@%brick.material[%rel]@"   ", %chance, %ascii), " ", "");
		%cl.centerPrint((%chance<=0.7?"<color:FFFFFF>Mining "@%mat:"")@"<br>\c6Health: "@%brick.healthOf[%rel]@"/"@%brick.origHealth[%rel], 3);
	}
}

function servercmdHelp(%cl)
{
	%cl.chatMessage("\c6Build a Station Core in an empty patch of space to start a station.");
	%cl.chatMessage("\c2Use a Fabricator to convert materials into other materials!");
	%cl.chatMessage("\c2/refuel [amount]\c6 - \c3refuels your tank with hydrazine.");
	%cl.chatMessage("\c2/dump [amount] [material]\c6 - \c3dumps an amount of a material.");
	%cl.chatMessage("\c2/listMats\c6 - \c3lists all your materials.");
}

function servercmdRefuel(%cl, %amt, %silent)
{
	if(!isObject(%pl = %cl.player)) { %cl.chatMessage("\c6Could not refuel!"); return; }
	%amt = getMin(%cl.matHydrazine, %amt);
	if(%pl.species $= "Robot") { %max = 2.5 - (%pl.getEnergyLevel() / 40); %mult = 40; }
	else { %max = 5 - (%pl.getEnergyLevel() / 20); %mult = 20; }
	%amt = getMin(%amt, %max);
	if(%amt <= 0)
	{
		%cl.chatMessage("\c6Could not refuel!");
		return;
	}
	if(!%silent) %cl.chatMessage("\c6Refueled "@mFloatLength(%amt * %mult, 1)@"%% of your fuel.");
	%cl.matHydrazine -= %amt; %cl.totalMats -= %amt; %pl.setEnergyLevel(%pl.getEnergyLevel() + %amt * %mult);
	if(%cl.hasRSClient) commandToClient(%cl, 'UpdateMaterial', mFloatLength(%cl.matHydrazine, 3), "Hydrazine");
}

//Temporary until there's a properly Newtonian way to get rid of excess
function servercmdDump(%cl, %amt, %mat, %silent)
{
	if(strLen(%mat) == 0) { %cl.chatMessage("\c6Too few arguments. Usage: \"/dump 5 Oxygen\"."); return; }
	%mats = materialList();
	for(%i=0;%i<getWordCount(%mats);%i++)
		if(getWord(%mats, %i) $= %mat)
		{ %mat = getWord(%mats, %i); %flag = 1; }
	if(!%flag) { %cl.chatMessage("\c6There is no material "@strUpr(getSubStr(%mat, 0, 1)) @ strLwr(getSubStr(%mat, 1, strLen(%mat) - 1))@"!"); return; }
	%amt = getMax(%cl.mat[%mat] - %amt, 0);
	%dumped = %cl.mat[%mat] - %amt;
	if(%dumped <= 0) return;
	%cl.mat[%mat] = %amt; %cl.totalMats -= %dumped;
	if(!%silent) %cl.chatMessage("\c6Dumped "@mFloatLength(%dumped, 3) SPC %mat);
	if(%cl.hasRSClient) commandToClient(%cl, 'UpdateMaterial', mFloatLength(%cl.mat[%mat], 3), %mat);
}

function servercmdStore(%cl, %amt, %mat, %silent)
{
	if(!isObject(%pl = %cl.player)) return;
	if(%amt $= "all")
	{
		%pos = %pl.getHackPosition();
		%count = StationCores.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%core = StationCores.getObject(%i);
			if(vectorDist(%pos, %core.getPosition()) >= 100) continue;
			%finalCore = %core; break;
		}
		if(!isObject(%finalCore)) { %cl.centerPrint("\c0You aren't inside a space station's area!", 3); return; }
		//if(vectorDist(%pos, %core.getPosition()) >= 10) { %cl.centerPrint("\c0 You aren't close enough to "@%core.stationName@"'s core to store materials in it!", 3); return; }
		//Readd this once there are proxy storage bricks or the core isn't where one stores materials
		%minTrust = (%core.hasVar["StoreTrust"] ? %core.getVar("StoreTrust") : 2);
		if(getTrustLevel(%pl, %core) < 2) { %cl.centerPrint("\c0You can't store materials in "@%core.stationName@"!", 3); return; }
		%mats = materialList();
		for(%i=0;%i<getWordCount(%mats);%i++)
		{
			%mat = getWord(%mats, %i);
			servercmdStore(%cl, %cl.mat[%mat], %mat, 1);
		}
		%cl.chatMessage("\c6Stored everything at "@%core.stationName@".");
		return;
	}
	%amt = getMin(%amt, %cl.mat[%mat]);
	if(%amt <= 0) return;
	%pos = %pl.getHackPosition();
	%count = StationCores.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%core = StationCores.getObject(%i);
		if(vectorDist(%pos, %core.getPosition()) >= 100) continue;   //Inside the station?
		%finalCore = %core; break;
	}
	if(!isObject(%finalCore)) { %cl.centerPrint("\c0You aren't inside a space station's area!", 3); return; }
	//if(vectorDist(%pos, %core.getPosition()) >= 10) { %cl.centerPrint("\c0 You aren't close enough to "@%core.stationName@"'s core to store materials in it!", 3); return; }
	//Readd this once there are proxy storage bricks or the core isn't where one stores materials
	%minTrust = (%core.hasVar["StoreTrust"] ? %core.getVar("StoreTrust") : 2);
	if(getTrustLevel(%pl, %core) < %minTrust) { %cl.centerPrint("\c0You can't store materials in "@%core.stationName@"!", 3); return; }
	if(%core.mat[%mat] >= 10000) { %cl.centerPrint("\c0"@%core.stationName@" can't store any more \""@%mat@"\"!", 3); return; }
	%amt = getMin(%amt, 10000 - %core.mat[%mat]); %core.mat[%mat] += %amt; %cl.mat[%mat] -= %amt; %cl.totalMats -= %amt;
	commandToClient(%cl, 'UpdateMaterial', mFloatLength(%cl.mat[%mat], 3), %mat);
	if(!%silent) %cl.chatMessage("\c6Stored "@mFloatLength(%amt, 3) SPC %mat@" at "@%core.stationName@".");
}

function servercmdTake(%cl, %amt, %mat, %silent)
{
	if(!isObject(%pl = %cl.player)) return;
	%pos = %pl.getHackPosition();
	%count = StationCores.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%core = StationCores.getObject(%i);
		if(vectorDist(%pos, %core.getPosition()) >= 100) continue;   //Inside the station?
		%finalCore = %core; break;
	}
	if(!isObject(%finalCore)) { %cl.centerPrint("\c0You aren't inside a space station's area!", 3); return; }
	//if(vectorDist(%pos, %core.getPosition()) >= 10) { %cl.centerPrint("\c0 You aren't close enough to "@%core.stationName@"'s core to take materials from it!", 3); return; }
	//Readd this once there are proxy storage bricks or the core isn't where one stores materials
	%minTrust = (%core.hasVar["TakeTrust"] ? %core.getVar("TakeTrust") : 2);
	if(getTrustLevel(%pl, %core) < %minTrust) { %cl.centerPrint("\c0You can't take materials from "@%core.stationName@"!", 3); return; }
	%amt = getMin(getMin(%amt, %cl.maxMats(%cl.pack == 4) - %cl.totalMats), %core.mat[%mat]);
	%core.mat[%mat] -= %amt; %cl.mat[%mat] += %amt; %cl.totalMats += %amt;
	commandToClient(%cl, 'UpdateMaterial', mFloatLength(%cl.mat[%mat], 3), %mat);
	if(!%silent) %cl.chatMessage("\c6Took "@mFloatLength(%amt, 3) SPC %mat@" from "@%core.stationName@".");
}

function servercmdPlaceMat(%cl, %mat)
{
	if(%cl.mat[%mat] < 1) return;
	if(!isObject(%pl = %cl.player)) return;
	%eye = %pl.getEyePoint();
	%dir = %pl.getEyeVector();
	%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%dir, 8)), $Typemasks::fxBrickAlwaysObjectType);
	if(isObject(%obj = firstWord(%ray)) && %obj.isAsteroid)
	{
		%asteroid = %obj.asteroidGroup;
		%pos = vectorAdd(getWords(%ray, 1, 3), vectorScale(getWords(%ray, 4, 6), 0.5));
		for(%i=0;%i<3;%i++) %pos = setWord(%pos, %i, mFloatLength(getWord(%pos, %i) - 0.5, 0) + 0.5);
		%data = createBrick(AsteroidGroup, brick2xCubeData, %pos, 6, 0);
		%brick = getField(%data, 0); %error = getField(%data, 1);
		if(%error && %error != 2) { %brick.delete(); return; }
		if(%brick.getMaxDist(%asteroid.centerPos) > 8.5) { %brick.delete(); return; }
		%asteroid.add(%brick); %brick.schedule(0, "addToAsteroid", %asteroid);
		%brick.healthOf["0 0 0"] = 10; %brick.origHealth["0 0 0"] = 10; %brick.material["0 0 0"] = %mat;
	}
	%cl.mat[%mat]--; %cl.totalMats--;
}

function GameConnection::giveResources(%cl, %brick)
{
	if(%brick.material["0 0 0"] !$= "") %mat = %brick.material["0 0 0"];
	else
	{
		%mats = (getRandom(0, 999) ? commonMaterials() : rareMaterials());
		%mat = getField(%mats, getRandom(0, getFieldCount(%mats) - 1));
	}
	%cl.mat[%mat] = %cl.mat[%mat] + 1; %cl.totalMats++;
	%cl.centerPrint("\c6Mined "@%mat@"; you now have "@%cl.mat[%mat]@" total!", 3);
	commandToClient(%cl, 'UpdateMaterial', %cl.mat[%mat], %mat);
}

function materialList() { return "Carbon\tHydrazine\tHydrogen\tIce\tIron\tLead\tNitrogen\tOxygen\tSteel\tUranium\tWater"; }
function commonMaterials() { return "Carbon\tIce\tIron\tNitrogen"; }
function rareMaterials() { return "Lead\tUranium"; }

function servercmdListMats(%cl, %cmd)
{
	%cmd = %cmd && %cl.hasRSClient;
	if(!%cmd) %cl.chatMessage("\c2Your materials:");
	%matList = materialList(); %count = getFieldCount(%matList);
	if(%cmd) for(%i=0;%i<%count;%i++) commandToClient(%cl, 'UpdateMaterial', mFloatLength(%cl.mat[%name = getField(%matList, %i)], 3), %name);
	else for(%i=0;%i<%count;%i++) { %name = getField(%matList, %i); %cl.mat[%name] = mFloatLength(%cl.mat[%name], 3); if(%cl.mat[%name] != 0) %cl.chatMessage("\c6"@%cl.mat[%name] SPC %name); }
	if(!%cmd)
	{
		%cl.chatMessage("\c6"@mFloatLength(%cl.totalMats, 3)@" Total");
		if(!isObject(%pl = %cl.player)) return;
		%pos = %pl.getHackPosition();
		if(isObject(StationCores))
		{
			%cores = StationCores.getCount();
			for(%i=0;%i<%cores;%i++)
			{
				%core = StationCores.getObject(%i);
				if(vectorDist(%pos, %core.getPosition()) >= 100) continue;
				%finalCore = %core; break;
			}
			if(!isObject(%finalCore)) return;
			%minTrust = (%core.hasVar["ListTrust"] ? %core.getVar("ListTrust") : 2);
			if(getTrustLevel(%pl, %core) < %minTrust) return;
			%cl.chatMessage("\c2"@%core.stationName@":");
			for(%i=0;%i<%count;%i++) { %name = getField(%matList, %i); %mat = mFloatLength(%core.mat[%name], 3); if(%mat != 0) %cl.chatMessage("\c6"@%mat SPC %name); %total += %mat; }
			%cl.chatMessage("\c6"@mFloatLength(%total, 3)@" Total");
		}
	}
}

function createBrokenBlocks(%newData, %pos, %shift, %data, %asteroid, %cl, %hitPos)
{
	%posList = "-1 -1 -1\t1 -1 -1\t-1 1 -1\t1 1 -1\t-1 -1 1\t1 -1 1\t-1 1 1\t1 1 1";
	for(%i=0;%i<8;%i++)
	{
		%info = createBrick(AsteroidGroup, %newData, vectorAdd(%pos, vectorScale(getField(%posList, %i), %shift)), 6, 0);
		%newBrick = getField(%info, 0); %error = getField(%info, 1);
		if(%error && %error != 2) { %newBrick.delete(); continue; }
		for(%z=-%shift+0.5;%z<=%shift;%z++)
			for(%y=-%shift+0.5;%y<=%shift;%y++)
				for(%x=-%shift+0.5;%x<=%shift;%x++)
				{
					%rel = %x SPC %y SPC %z;
					%origRel = vectorAdd(%rel, vectorScale(getField(%posList, %i), %shift));
					%newBrick.healthOf[%rel] = %data.healthOf[%origRel];
					%newBrick.origHealth[%rel] = %data.origHealth[%origRel];
					%newBrick.material[%rel] = %data.material[%origRel];
				}
		%asteroid.add(%newBrick); %newBrick.addToAsteroid(%asteroid);
		if((%dist = vectorDist(%newBrick.getPosition(), %hitPos)) < %least || %least $= "")
		{ %least = %dist; %break = %newBrick; }
	}
	if(isObject(%break)) %break.mineAsteroid(%cl, %hitPos);
	%data.delete();
}