datablock ExplosionData(SpacePickExplosion)
{
   lifeTimeMS = 400;

   particleEmitter = HammerExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "0.5 0.5 0.5";
   camShakeDuration = 0.25;
   camShakeRadius = 5.0;

   lightStartRadius = 1.5;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


datablock ItemData(SpacePickItem : swordItem)
{
	shapeFile = "./Pickaxe.dts";
	uiName = "Pickaxe";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	image = SpacePickImage;
	canDrop = true;
	iconName = "./PickaxeIcon";
};

datablock ProjectileData(SpacePickProjectile)
{
   explosion           = SpacePickExplosion;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Pickaxe";
};



datablock ShapeBaseImageData(SpacePickImage)
{
   shapeFile = "./Pickaxe.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";

   correctMuzzleVector = false;

   className = "WeaponImage";

   item = SpacePickItem;
   ammo = " ";
   projectile = SpacePickProjectile;
   projectileType = Projectile;


   melee = true;
   doRetraction = false;

   armReady = true;


   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function SpacePickImage::onPreFire(%this, %obj, %slot)
{ %obj.playThread(2, "ArmAttack"); }

function SpacePickImage::onStopFire(%this, %obj, %slot)
{ %obj.playThread(2, "Root"); }



function SpacePickProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	serverPlay3DSpace(HammerHitSound, %pos);
	if(%col.isAsteroid) { %pos = vectorSub(%pos, vectorScale(%normal, 0.5)); for(%i=0;%i<3;%i++) %pos = setWord(%pos, %i, mFloatLength(getWord(%pos, %i) - 0.5, 0) + 0.5); %col.mineAsteroid(%obj.client, %pos); }
}