function Player::getMass(%pl)
{
	//Add inventory item weights
	//2 = 1 kg.
	if(%pl.species $= "Robot")
	{
		%mass = 96.5;   //Full-suit mass: 100; full-pack mass: 200
		%scale = %pl.getScale(); for(%i=0;%i<3;%i++) %mass *= getWord(%scale, %i);
		%mass += %pl.client.totalMats + (%pl.getEnergyLevel() / 40) + (%pl.oxygenLevel / 100);
	}
	else if(%pl.species $= "Zoltan")
	{
		%mass = 50;   //Full-suit mass: 60; full-pack mass: 210
		%scale = %pl.getScale(); for(%i=0;%i<3;%i++) %mass *= getWord(%scale, %i);
		%mass += %pl.client.totalMats + (%pl.getEnergyLevel() / 20) + (%pl.oxygenLevel / 20);
	}
	else
	{
		%mass = 90;   //Full-suit mass: 100; full-pack mass: 250
		%scale = %pl.getScale(); for(%i=0;%i<3;%i++) %mass *= getWord(%scale, %i);
		%mass += %pl.client.totalMats + (%pl.getEnergyLevel() / 20) + (%pl.oxygenLevel / 20);
	}
	%mass += %pl.ammo45 * 0.024;
	if($RSM::Featherweight) %mass = 2;
	return %mass;
}

function GameConnection::maxMats(%cl, %backpack)
{
	switch$(%cl.species)
	{
		case "Human": %base = 25; %pack = 125;
		case "Robot": %base = 100; %pack = 0;
		case "Zoltan": %base = 30; %pack = 30;
		default: %base = 25; %pack = 0;
	}
	return %base + %pack * %backpack;
}