package RSM_RadioChat
{
	function servercmdMessageSent(%cl, %msg) { }
	function servercmdStartTalking(%cl) { }
	function servercmdStopTalking(%cl) { }
};
activatePackage("RSM_RadioChat");

function servercmdSendCommMessage(%cl, %channel, %msgData)
{
	if(strLen(%channel) != 2) return;   //Channel must be two hexadecimal characters.
	if((%len = strLen(%msgData)) == 0) return;   //Message data must not be empty. Why would you waste battery?
	if(%len % 4 != 0) return;   //Message data is encoded in Base 64.
	for(%i=0;%i<2;%i++) if(striPos("0123456789ABCDEF", getSubStr(%channel, %i, 1)) == -1)
			return; //Again, the channel must be two hexadecimal characters.
	%validBase64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	for(%i=0;%i<%len;%i++)
	{
		if(%i == (%len - 2)) %validBase64 = %validBase64 @ "=";
		if(striPos(%validBase64, getSubStr(%msgData, %i, 1)) == -1)
			return;   //The message data must be valid Base 64 data.
	}
	%array = new ScriptObject() { class = "ByteArraySO"; };
	%array.FromBase64(%msgData); %array.bytes = getMin(%array.bytes, 160);
	%cost = %array.bytes * 0.01 + 0.05;
	if(%cl.batteryPower < %cost) return;
	%cl.batteryPower = getMax(getMin(%cl.batteryPower - %cost, 100), 0);
	//echo("[COMM] "@%cl.name@": "@%msg);
	if($FlareDisruption > 0)
	{
		//41.6667 and 20.8333 are 2500 and 1250 divided by 60.
		%range = (41.6667 * $RSM::AsteroidDist) - (mSqrt($FlareDisruption / $FlareDisruptLength) * 20.8333 * $RSM::AsteroidDist);
		%power = 4 - mSqrt($FlareDisruption / $FlareDisruptLength) * 2.25;
	}
	else
	{
		%range = 41.6667 * $RSM::AsteroidDist;
		%power = 4;
	}
	if(!isObject(%pl = %cl.player))
		%pl = %cl.persistentPlayer;
	if(isObject(%pl))
	{
		%pos = %pl.getHackPosition();
		%plVel = %pl.getVelocity();
	}
	else
	{
		%pos = "0 0 "@(34.1383*$RSM::AsteroidDist);
		%plVel = "0 0 0";
	}
	if(isObject(CommRelays))
	{
		%relays = CommRelays.getCount();
		for(%i=0;%i<%relays;%i++)
		{
			%test = CommRelays.getObject(%i);
			%dist = vectorDist(%pos, %test.getPosition());
			if(%dist < %leastDist || %leastDist $= "")
			{ %leastDist = %dist; %alphaRelay = %test; }
		}
	}
	%count = ClientGroup.getCount();
	%newArray = new ScriptObject() { class = "ByteArraySO"; };
	for(%i=0;%i<%count;%i++)
	{
		%this = ClientGroup.getObject(%i);
		if(!isObject(%obj = %this.player))
			%obj = %this.persistentPlayer;
		if(isObject(%obj))
		{
			%loc = %obj.getHackPosition();
			%objVel = %obj.getVelocity();
		}
		else
		{
			%loc = "0 0 "@(34.1383*$RSM::AsteroidDist);
			%objVel = "0 0 0";
		}
		%dist = vectorDist(%pos, %loc);
		if(isObject(%alphaRelay))
		{
			%leastDist = ""; %betaRelay = "";
			for(%j=0;%j<%relays;%j++)
			{
				%test = CommRelays.getObject(%j);
				%relayDist = vectorDist(%loc, %test.getPosition());
				if(%relayDist < %leastDist || %leastDist $= "")
				{ %leastDist = %relayDist; %betaRelay = %test; }
			}
			if(isObject(%betaRelay))
			{
				%relayDist = vectorDist(%pos, %alphaRelay.getPosition()) + vectorDist(%alphaRelay.getPosition(), %betaRelay.getPosition()) / 20 + vectorDist(%betaRelay.getPosition(), %loc);
				%dist = getMin(%dist, %relayDist);
			}
		}
		if(%dist < %range)
		{
			%chance = mPow(%dist / %range, %power);
			for(%j=0;%j<%array.bytes;%j++)
			{
				%byte = %array.byte[%j];
				for(%k=0;%k<8;%k++)
				{
					%mask = 128 >> %k;
					%bit = (getRandom() > %chance ? %byte & %mask : getRandom(0, 1) * %mask);
					%byte = (%byte & (~%mask)) | %bit;
				}
				%newArray.byte[%j] = %byte;
			}
			%newArray.bytes = %array.bytes;
			%base64Data = %newArray.ToBase64();
			
			%radius = 0.1 * %chance * vectorDist(%pos, %loc);
			%newArray.bytes = 12;
			%posOffset = %radius * mPow(getRandom(), 1/3) * getUnitVector();
			%relPos = vectorAdd(vectorSub(%pos, %loc), %posOffset);
			%velOffset = 0.1 * %radius * getRandom() * getUnitVector();
			%relVel = vectorAdd(vectorSub(%plVel, %objVel), %velOffset);
			for(%j=0;%j<3;%j++)
			{
				%motion[%j] = ToFloat16(getWord(%relPos, %j));
				%motion[%j + 3] = ToFloat16(getWord(%relVel, %j));
			}
			for(%j=0;%j<6;%j++)
			{
				%newArray.byte[%j * 2] = %motion[%j] >> 8;
				%newArray.byte[%j * 2 + 1] = %motion[%j] & 255;
			}
			%relativeMotion = %newArray.ToBase64();
			
			commandToClient(%this, 'ReceiveCommMessage', %channel, %base64Data, %relativeMotion);
		}
	}
	%array.delete(); %newArray.delete();
}

function applyDistortion(%in, %chance, %chars)
{
	%len = strLen(%in);
	%charLen = strLen(%chars);
	for(%i=0;%i<%len;%i++)
		%out = %out @ (getRandom() > %chance ? getSubStr(%in, %i, 1) : getSubStr(%chars, getRandom(0, %charLen - 1), 1));
	return %out;
}

function brickCommsRelayData::onAdd(%data, %brick)
{
	if(!%brick.isPlanted()) return;
	if(!isObject(CommRelays)) new SimSet(CommRelays);
	CommRelays.add(%brick);
}

registerOutputEvent("fxDtsBrick", "setTransponder", "bool");
function fxDtsBrick::setTransponder(%brick, %on)
{ %brick.setVar("TransponderSilence", !%on); }

function brickTransponderData::onAdd(%data, %brick)
{
	if(!%brick.isPlanted()) return;
	if(!isObject(StationTransponders))
	{
		new SimSet(StationTransponders);
		$TransponderPing = schedule(5000, 0, "TransponderPing");
	}
	StationTransponders.add(%brick);
}

function TransponderPing()
{
	cancel($TransponderPing);
	%pings = StationTransponders.getCount();
	for(%i=0;%i<%pings;%i++)
	{
		%ping = StationTransponders.getObject(%i);
		//if(%ping.stationCore.getGroup().name $= "Zoltan") talk(%ping);
		if(%ping.getVar("TransponderSilence")) continue;
		%core = %ping.stationCore.getID();
		if(%hasPinged[%core]) continue;
		%count = ClientGroup.getCount();
		for(%j=0;%j<%count;%j++)
		{
			%this = ClientGroup.getObject(%j);
			if(!%this.hasRSClient) continue;
			if(!isObject(%pl = %this.player) || vectorDist(%pl.getHackPosition(), %core.getPosition()) > 2500)
			{
				if(%this.knowsStation[%core])
					commandToClient(%this, 'RSC_UpdateDirMarker', "Core_"@%core.getID(), "DELETE");
				%this.knowsStation[%core] = 0;
			}
			else if(!%this.knowsStation[%core])
			{
				commandToClient(%this, 'RSC_UpdateDirMarker', "Core_"@%core.getID(), %core.getPosition(), "1 0 1 1", %core.stationName, 0.9975);
				%this.knowsStation[%core] = 1;
			}
		}
		%hasPinged[%core] = 1;
	}
	%cores = StationCores.getCount();
	for(%i=0;%i<%cores;%i++)
	{
		%core = StationCores.getObject(%i); if(%hasPinged[%core]) continue;
		for(%j=0;%j<%count;%j++)
		{
			%this = ClientGroup.getObject(%j);
			if(!%this.hasRSClient) continue;
			if(%this.knowsStation[%core])
				commandToClient(%this, 'RSC_UpdateDirMarker', "Core_"@%core.getID(), "DELETE");
			%this.knowsStation[%core] = 0;
		}
	}
	$TransponderPing = schedule(5000, 0, "TransponderPing");
}