function SolarFlareLoop(%timeLeft, %warnTime)
{
	cancel($SolarFlareLoop);
	%timeLeft--;
	$FlareDisruption--;
	if(%timeLeft <= 0)
	{
		%count = ClientGroup.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!isObject(%pl = %cl.player))
				continue;
			%cl.play2D(SolarFlareSound);
			if(%test = %pl.testSolarFlare()) %pl[-1+%pls++] = %pl;
			%pl.flareHistory = %pl.flareHistory @ %test;
			if((%histLen = strLen(%pl.flareHistory)) > 5)
				%pl.flareHistory = getSubStr(%pl.flareHistory, %histLen - 5, 5);
		}
		if(isObject(PersistentPlayers))
		{
			%count = PersistentPlayers.getCount();
			for(%i=0;%i<%count;%i++)
			{
				%pl = PersistentPlayers.getObject(%i);
				if(%test = %pl.testSolarFlare()) %pl[-1+%pls++] = %pl;
				%pl.flareHistory = %pl.flareHistory @ %test;
				if((%histLen = strLen(%pl.flareHistory)) > 5)
					%pl.flareHistory = getSubStr(%pl.flareHistory, %histLen - 5, 5);
			}
		}
		messageAll('', "<color:FF4000>Solar flare impact.");
		$FlareDisruption = getRandom(150, 300);
		$FlareDisruptLength = $FlareDisruption;
		for(%i=0;%i<%pls;%i++)
		{
			%pl = %pl[%i];
			%hits = strLen(strReplace(%pl.flareHistory, "0", ""));
			if(%pl.species $= "Robot")
			{
				if(%hits >= 2) %pl.kill();
				else
				{
					%pl.addStunTime(60);
				}
			}
			else if(%pl.species $= "Zoltan")
			{
				if(%hits >= 3) %pl.kill();
				else
				{
					//?!?!?!
				}
			}
			else if(%pl.species $= "Human")
			{
				if(%hits >= 4) %pl.kill();
				else
				{
					//?!?!?!
				}
			}
		}
		%timeLeft = getRandom(1500, 2100);
		%warnTime = getRandom(150, 45);
	}
	else if(%timeLeft == %warnTime)
	{
		messageAll('', "<color:FF8000>WARNING\c6: Solar flare imminent.");
		%count = ClientGroup.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%cl = ClientGroup.getObject(%i);
			if(!isObject(%pl = %cl.player)) continue;
			%cl.play2D(FlareWarningSound);
		}
	}
	$SolarFlareLoop = schedule(1000, 0, "SolarFlareLoop", %timeLeft, %warnTime);
}
if(!isEventPending($SolarFlareLoop))
	SolarFlareLoop(getRandom(3000, 4200), getRandom(150, 45));

function doNothing(){}   //Remove this

function Player::testSolarFlare(%pl)
{
	if($RSM::Sandbox) return 0;
	%azim = mDegToRad(Sun.azimuth); %elev = mDegToRad(Sun.elevation);
	%dir = mSin(%azim)*mCos(%elev) SPC mCos(%azim)*mCos(%elev) SPC mSin(%elev);
	%axis0 = vectorNormalize(vectorCross(%dir, getUnitVector()));
	%axis1 = vectorCross(%dir, %axis0); %vector0 = "0 0 0"; for(%i=0;%i<20;%i++)
	%vector[%i+1] = vectorAdd(vectorScale(%axis0, mSin(%i / 10 * $PI)), vectorScale(%axis1, mCos(%i / 10 * $PI)));
	for(%rays=0;%rays<21;%rays++)
	{
		%start = %pl.getHackPosition();
		%aim = vectorAdd(vectorScale(%dir, 128), vectorScale(%vector[%rays], 8));
		for(%try=0;%try<5;%try++)
		{
			%ray = containerRaycast(%start, vectorAdd(%start, %aim), $Typemasks::fxBrickObjectType);
			if(isObject(%ray)) { %fry = 0; break; }
			%start = vectorAdd(%start, %aim); %fry = 1;
		}
		if(%fry) return 1;
	}
	return 0;
}

datablock AudioProfile(FlareWarningSound)
{
	filename = "./Sounds/Flare Warning.wav";
	description = AudioClosest3D; preload = false;
};

datablock AudioProfile(SolarFlareSound)
{
	filename = "./Sounds/Solar Flare.wav";
	description = AudioClosest3D; preload = false;
};