function servercmdSpecies(%cl, %species, %confirm)
{
	if(DT_getTimeDifference($Pref::Server::SpeciesUpdate, $PersistentChooseTime[%cl.bl_id]) > 0 && %cl.species !$= "")
	{ %cl.chatMessage("<color:FFFFFF>You can't change your species!"); return; }
	if(!%cl.hasSpawnedOnce) { %cl.chatMessage("<color:FFFFFF>You have to spawn to change your species!"); return; }
	if(%cl.species !$= "" && !isObject(%pl = %cl.player)) { %cl.chatMessage("<color:FFFFFF>You have to have a player to change your species!"); return; }
	if(isObject(%pl))
	{
		if(isObject(StationCores))
		{
			%cores = StationCores.getCount();
			for(%i=0;%i<%cores;%i++)
			{
				%core = StationCores.getObject(%i);
				if(vectorDist(%pl.getHackPosition(), %core.getPosition()) <= 100 &&
					%core.getGasPressure(%pl.getEyePoint(), 0) >= 2) %safe = 1;
			}
		}
		if(!%safe) { %cl.chatMessage("<color:FFFFFF>You must be in a safe location to change your species!"); return; }
	}
	if(%species $= "")
	{
		servercmdSpecies(%cl, "Human");
		servercmdSpecies(%cl, "Robot");
		servercmdSpecies(%cl, "Zoltan");
		%cl.chatMessage("<color:FFFFFF>Features in gray have not yet been implemented but are planned.");
		%cl.chatMessage("<color:FFFFFF>Use the Page Up key to view more of the text, or \"\c2/species\c3 (name)\c6\" to view a single species.");
		%cl.chatMessage("<color:FFFFFF>You must use \"\c2/species\c3 confirm (name)\c6\" to choose a species. Use \"\c2/species\c3 list\c6\" to list the species' names only.");
		%cl.chatMessage("<color:FF8000>THIS CHOICE CANNOT BE CHANGED!\c6 Put some serious thought into which species you want to be!");
		return;
	}
	else if(%species $= "List")
	{
		%cl.chatMessage("<color:FFFFFF>BIOLOGICAL");
		%cl.chatMessage("<color:FFFFFF>    Human - Humans are by far the most adaptible of the known species, changing tactics for new problems as they appear.");
		%cl.chatMessage("<color:FFFFFF>    Zoltan - Zoltan are bioelectric creatures powerful enough to power entire systems or stun nearby robots.");
		%cl.chatMessage("<color:FFFFFF>MECHANICAL");
		%cl.chatMessage("<color:FFFFFF>    Robot - Robots are able to survive without oxygen, and interface far better with computers than the other species.");
	}
	else if(%species $= "Human")
	{
		%cl.chatMessage("<color:FFFFFF>HUMAN");
		%cl.chatMessage("<color:FFFFFF>        Humans are by far the most adaptible of the known species, changing tactics for new problems as they appear.");
		%cl.chatMessage("<color:FFFFFF>  Advantages:");
		%cl.chatMessage("<color:FFFFFF>   Humans are extremely resilient to solar flares.");
		%cl.chatMessage("<color:FFFFFF>   Humans can choose between maximum storage space or maximum oxygen lifetime.");
		%cl.chatMessage("<color:FFFFFF>  Disadvantages:");
		%cl.chatMessage("<color:FFFFFF>   Humans require a constant supply of oxygen, and will die without such a supply.");
		%cl.chatMessage("<color:FFFFFF>  Statistics:");
		%cl.chatMessage("<color:FFFFFF>    25 storage space (+125 if wearing the Backpack)");
		%cl.chatMessage("<color:FFFFFF>    ~20 minutes' airtime (~2 hours if wearing the Oxygen Tanks)");
		%cl.chatMessage("<color:FFFFFF>    Base mass: 50 kilograms");
		%cl.chatMessage("<color:FFFFFF>    EVA tank size: 5 hydrazine");
	}
	else if(%species $= "Robot")
	{
		%cl.chatMessage("<color:FFFFFF>ROBOT");
		%cl.chatMessage("<color:FFFFFF>        Robots are able to survive without oxygen, and interface far better with computers than the other species.");
		%cl.chatMessage("<color:FFFFFF>  Advantages:");
		%cl.chatMessage("<color:FFFFFF>   Robots don't require oxygen and can stay in space for arbitrary lengths of time.");
		%cl.chatMessage("<color:FFFFFF>   Robots have 100 storage space, as opposed to lesser amounts for most other species.");
		%cl.chatMessage("<color:FFFFFF>  Disadvantages:");
		%cl.chatMessage("<color:FFFFFF>   Robots are much more vulnerable to solar flares than the other species.");
		%cl.chatMessage("<color:FFFFFF>   Robots can't change their avatar beyond overall color.");
		%cl.chatMessage("<color:FFFFFF>  Statistics:");
		%cl.chatMessage("<color:FFFFFF>    100 storage space");
		%cl.chatMessage("<color:FFFFFF>    Oxygen tank for rescues (keeps one human alive for an additional ~4 minutes, or ~24 with oxygen tanks)");
		%cl.chatMessage("<color:FFFFFF>    Base mass: 50 kilograms");
		%cl.chatMessage("<color:FFFFFF>    EVA tank size: 2.5 hydrazine");
	}
	else if(%species $= "Zoltan")
	{
		%cl.chatMessage("<color:FFFFFF>ZOLTAN");
		%cl.chatMessage("<color:FFFFFF>        Zoltan are bioelectric creatures powerful enough to power entire systems or stun nearby robots.");
		%cl.chatMessage("<color:FFFFFF>  Advantages:");
		%cl.chatMessage("<color:606060>   Zoltan can power systems, allowing them to use systems without worrying about draining power.");
		%cl.chatMessage("<color:FFFFFF>   Zoltan are smaller and lighter than the other species, letting them maneuver with greater power.");
		%cl.chatMessage("<color:606060>   Zoltan can release an electromagnetic pulse which stuns any nearby electronics.");
		%cl.chatMessage("<color:FFFFFF>  Disadvantages:");
		%cl.chatMessage("<color:FFFFFF>   Zoltan have a fast metabolism, causing them to consume oxygen faster than humans.");
		%cl.chatMessage("<color:606060>   Zoltan are badly stunned by solar flares, though not as badly as robots.");
		%cl.chatMessage("<color:606060>   Zoltan have lower health than humans, making them poor choices for combatants.");
		%cl.chatMessage("<color:FFFFFF>  Statistics:");
		%cl.chatMessage("<color:FFFFFF>    30 storage space (+30 if wearing the Backpack)");
		%cl.chatMessage("<color:FFFFFF>    ~10 minutes' airtime (~1 hour if wearing the Oxygen Tanks)");
		%cl.chatMessage("<color:FFFFFF>    Base mass: 30 kilograms");
		%cl.chatMessage("<color:FFFFFF>    EVA tank size: 5 hydrazine");
	}
	else if(%species $= "Confirm")
	{
		if(%confirm $= "Human")
		{
			%cl.species = "Human";
			if(isObject(%pl = %cl.player))
				%pl.species = "Human";
			%cl.choosingSpecies = 0;
			%cl.chatMessage("<color:FFFFFF>Chose the Human species!");
		}
		else if(%confirm $= "Robot")
		{
			%cl.species = "Robot";
			%cl.suitDamage = 0;
			if(isObject(%pl = %cl.player))
			{
				%pl.species = "Robot";
				%pl.setLeakAudio();
			}
			%cl.choosingSpecies = 0;
			%cl.chatMessage("<color:FFFFFF>Chose the Robot species!");
		}
		else if(%confirm $= "Zoltan")
		{
			%cl.species = "Zoltan";
			if(isObject(%pl = %cl.player))
			{
				%pl.species = "Zoltan";
				%pl.setPlayerScale(0.822071);
			}
			%cl.choosingSpecies = 0;
			%cl.chatMessage("<color:FFFFFF>Chose the Zoltan species!");
		}
		else { %cl.chatMessage("<color:FFFFFF>Unknown species \""@%species@"\"."); return; }
		if(%cl.species !$= "")
		{
			servercmdUpdateBodyParts(%cl, %cl.hat, %cl.accent, %cl.pack, %cl.secondPack, %cl.chest, %cl.hip, %cl.lLeg, %cl.rLeg, %cl.lArm, %cl.rArm, %cl.lHand, %cl.rHand);
			servercmdUpdateBodyColors(%cl, %cl.headColor, %cl.hatColor, %cl.accentColor, %cl.packColor, %cl.secondPackColor, %cl.chestColor, %cl.hipColor,
				%cl.lLegColor, %cl.rLegColor, %cl.lArmColor, %cl.rArmColor, %cl.lHandColor, %cl.rHandColor, %cl.faceName, %cl.decalName);
			$PersistentChooseTime[%cl.bl_id] = getDateTime();
		}
	}
	else { %cl.chatMessage("<color:FFFFFF>Unknown species \""@%species@"\"."); return; }
}