$TetherLength = 8;

function TetherLoop(%plA, %plB, %last)
{
	if(!isObject(%plA) || !isObject(%plB)) return;
	%time = vectorDist(%last, %now = getSimTime());
	%dist = vectorDist(%posA = %plA.getHackPosition(), %posB = %plB.getHackPosition());
	if(%dist > $TetherLength)
	{
		%dir = vectorNormalize(vectorSub(%posB, %posA));
		%axis0 = vectorNormalize(vectorCross(%dir, "0 0 1"));
		%axis1 = vectorNormalize(vectorCross(%dir, %axis0));
		%velA = %plA.getVelocity(); %velB = %plB.getVelocity();
		%sumVel = vectorScale(vectorAdd(%velA, %velB), 0.5);
		%velA = vectorSub(%velA, %sumVel);
		%velB = vectorSub(%velB, %sumVel);
		//New model - takes mass into account   - constant velocity display doesn't work yet
	//	if(vectorDot(vectorNormalize(%velA), vectorNormalize(%dir)) < 0)
	//	{
	//		%massA = %plA.getMass(); %massB = %plB.getMass();
	//		%massT = %massA + %massB; %rel = vectorNormalize(%dir);
	//		%lenA = vectorLen(%velA); %lenB = vectorLen(%velB);
	//		%coef = 1;   //Elastic
	//		%nLenA = (%coef * %lenA * (%massA - %massB) + (%massA * %lenA) + (%massB * %lenB)) / %massT;
	//		%nLenB = (%coef * %lenB * (%massB - %massA) + (%massA * %lenA) + (%massB * %lenB)) / %massT;
	//		%plA.lastVel = vectorAdd(%plA.lastVel, vectorScale(%rel, %nLenA));
	//		%plB.lastVel = vectorAdd(%plB.lastVel, vectorScale(%rel, -%nLenB));
	//		%plA.addVelocity(vectorScale(%rel, %nLenA));
	//		%plB.addVelocity(vectorScale(%rel, -%nLenB));
	//	}
		//Old model - does not take mass into account
		%rel = Solve3DMatrix(%velA, %dir, %axis0, %axis1);
		if(getWord(%rel, 0) < 0) %add = (getWord(%rel, 0) * 2) - (%dist - $TetherLength) * 0.1;
		%plA.lastVel = vectorAdd(%plA.lastVel, vectorScale(%dir, -%add));
		%plB.lastVel = vectorAdd(%plB.lastVel, vectorScale(%dir, %add));
		%plA.addVelocity(vectorScale(%dir, -%add));
		%plB.addVelocity(vectorScale(%dir, %add));
	}
	%sched = schedule(16, 0, "TetherLoop", %plA, %plB, %now);
	%plA.TetherLoop = %sched; %plB.TetherLoop = %sched;
}

//3D Matrix solver
function Solve3DMatrix(%pos, %unit0, %unit1, %unit2)
{
	if(vectorLen(%unit0) == 0) return "Unsolvable";
	if(vectorLen(%unit1) == 0) return "Unsolvable";
	if(vectorLen(%unit2) == 0) return "Unsolvable";
	for(%i=0;%i<3;%i++)
	{
		if((%x[%i] = getWord(%unit[%i], 0)) != 0) %x++;
		if((%y[%i] = getWord(%unit[%i], 1)) != 0) %y++;
		if((%z[%i] = getWord(%unit[%i], 2)) != 0) %z++;
	}
	%x3 = getWord(%pos, 0); %y3 = getWord(%pos, 1); %z3 = getWord(%pos, 2);
	if(%x == 0 || %y == 0 || %z == 0) return "Unsolvable";
	for(%i=0;%i<3;%i++)
	{
		if(%x[%i] != 0) %i[%i]++;
		if(%y[%i] != 0) %i[%i]++;
		if(%z[%i] != 0) %i[%i]++;
	}
	if(%i0 == 1)
	{
		if(%x0 == 0)
			if(%y0 != 0)
			{
				%t0 = %x0; %t1 = %x1; %t2 = %x2; %t3 = %x3;
				%x0 = %y0; %x1 = %y1; %x2 = %y2; %x3 = %y3;
				%y0 = %t0; %y1 = %t1; %y2 = %t2; %y3 = %t3;
			}
			else
			{
				%t0 = %x0; %t1 = %x1; %t2 = %x2; %t3 = %x3;
				%x0 = %z0; %x1 = %z1; %x2 = %z2; %x3 = %z3;
				%z0 = %t0; %z1 = %t1; %z2 = %t2; %z3 = %t3;
			}
		if(%y1 == 0 || %z2 == 0)
		{
			%t0 = %y0; %t1 = %y1; %t2 = %y2; %t3 = %y3;
			%y0 = %z0; %y1 = %z1; %y2 = %z2; %y3 = %z3;
			%z0 = %t0; %z1 = %t1; %z2 = %t2; %z3 = %t3;
		}
	}
	else if(%i1 == 1)
	{
		if(%y1 == 0)
			if(%x1 != 0)
			{
				%t0 = %x0; %t1 = %x1; %t2 = %x2; %t3 = %x3;
				%x0 = %y0; %x1 = %y1; %x2 = %y2; %x3 = %y3;
				%y0 = %t0; %y1 = %t1; %y2 = %t2; %y3 = %t3;
			}
			else
			{
				%t0 = %y0; %t1 = %y1; %t2 = %y2; %t3 = %y3;
				%y0 = %z0; %y1 = %z1; %y2 = %z2; %y3 = %z3;
				%z0 = %t0; %z1 = %t1; %z2 = %t2; %z3 = %t3;
			}
		if(%x0 == 0 || %z2 == 0)
		{
			%t0 = %x0; %t1 = %x1; %t2 = %x2; %t3 = %x3;
			%x0 = %z0; %x1 = %z1; %x2 = %z2; %x3 = %z3;
			%z0 = %t0; %z1 = %t1; %z2 = %t2; %z3 = %t3;
		}
	}
	else if(%i2 == 1)
	{
		if(%z2 == 0)
			if(%x2 != 0)
			{
				%t0 = %x0; %t1 = %x1; %t2 = %x2; %t3 = %x3;
				%x0 = %z0; %x1 = %z1; %x2 = %z2; %x3 = %z3;
				%z0 = %t0; %z1 = %t1; %z2 = %t2; %z3 = %t3;
			}
			else
			{
				%t0 = %y0; %t1 = %y1; %t2 = %y2; %t3 = %y3;
				%y0 = %z0; %y1 = %z1; %y2 = %z2; %y3 = %z3;
				%z0 = %t0; %z1 = %t1; %z2 = %t2; %z3 = %t3;
			}
		if(%x0 == 0 || %y1 == 0)
		{
			%t0 = %x0; %t1 = %x1; %t2 = %x2; %t3 = %x3;
			%x0 = %y0; %x1 = %y1; %x2 = %y2; %x3 = %y3;
			%y0 = %t0; %y1 = %t1; %y2 = %t2; %y3 = %t3;
		}
	}
	else
	{
		if(%x0 == 0)
		{
			%t0 = %x0; %t1 = %x1; %t2 = %x2; %t3 = %x3;
			%x0 = %y0; %x1 = %y1; %x2 = %y2; %x3 = %y3;
			%y0 = %t0; %y1 = %t1; %y2 = %t2; %y3 = %t3;
		}
		if(%y1 == 0 || %z2 == 0)
		{
			%t0 = %y0; %t1 = %y1; %t2 = %y2; %t3 = %y3;
			%y0 = %z0; %y1 = %z1; %y2 = %z2; %y3 = %z3;
			%z0 = %t0; %z1 = %t1; %z2 = %t2; %z3 = %t3;
		}
	}
	if(%x0 == 0 || %y1 == 0 || %z2 == 0) return "Unsolvable";
	%scale = %y0 / %x0; %y0 -= %x0 * %scale; %y1 -= %x1 * %scale; %y2 -= %x2 * %scale; %y3 -= %x3 * %scale;
	%scale = %z0 / %x0; %z0 -= %x0 * %scale; %z1 -= %x1 * %scale; %z2 -= %x2 * %scale; %z3 -= %x3 * %scale;
	%scale = %z1 / %y1; %z0 -= %y0 * %scale; %z1 -= %y1 * %scale; %z2 -= %y2 * %scale; %z3 -= %y3 * %scale;
	%scale = %z2; %z0 /= %scale; %z1 /= %scale; %z2 /= %scale; %z3 /= %scale;
	%scale = %y2 / %z2; %y0 -= %z0 * %scale; %y1 -= %z1 * %scale; %y2 -= %z2 * %scale; %y3 -= %z3 * %scale;
	%scale = %x2 / %z2; %x0 -= %z0 * %scale; %x1 -= %z1 * %scale; %x2 -= %z2 * %scale; %x3 -= %z3 * %scale;
	%scale = %y1; %y0 /= %scale; %y1 /= %scale; %y2 /= %scale; %y3 /= %scale;
	%scale = %x1 / %y1; %x0 -= %y0 * %scale; %x1 -= %y1 * %scale; %x2 -= %y2 * %scale; %x3 -= %y3 * %scale;
	%scale = %x0; %x0 /= %scale; %x1 /= %scale; %x2 /= %scale; %x3 /= %scale;
	return %x3 SPC %y3 SPC %z3;
}
