package RSM_Trading
{
	//Temporary trading system
	function servercmdMessageSent(%cl, %msg)
	{
		if((isObject(%this = %cl.tradingWith) && getSubStr(%msg, 0, 1) $= "!") || %msg $= "!Help" || firstWord(%msg) $= "!Trade")
		{
			if(vectorDist(%cl.lastTradeCmd, %now = getSimTime()) < 500) return;
			%cl.lastTradeCmd = %now;
			%data = getSubStr(%msg, 1, strLen(%msg) - 1);
			%cmd = firstWord(%data);
			switch$(%cmd)
			{
				case "Accept":
					%mats = materialList();
					for(%i=0;%i<getWordCount(%mats);%i++)
					{
						%mat = getWord(%mats, %i);
						%toCl += %this.trade[%mat];
						%fromCl += %cl.trade[%mat];
					}
					%clPackMax = %cl.maxMats(%cl.pack == 4); %thisPackMax = %this.maxMats(%this.pack == 4);
					if(%cl.totalMats - %fromCl + %toCl > %clPackMax) { %cl.chatMessage("\c6Could not accept trade: your pack would be overfilled!"); return; }
					if(%this.totalMats - %toCl + %fromCl > %thisPackMax) { %cl.chatMessage("\c6Could not accept trade: "@%this.name@"'s pack would be overfilled!"); return; }
					%cl.acceptTrade = 1; %cl.chatMessage("\c6Accepted trade!"); %this.chatMessage("\c6"@%cl.name@" has accepted the trade!");
					if(%this.acceptTrade)
					{
						for(%i=0;%i<getWordCount(%mats);%i++)
						{
							%mat = getWord(%mats, %i);
							%cl.mat[%mat] += %this.trade[%mat];
							%this.mat[%mat] += %cl.trade[%mat];
							%cl.mat[%mat] -= %cl.trade[%mat];
							%this.mat[%mat] -= %this.trade[%mat];
						}
						%cl.totalMats += %toCl - %fromCl;
						%this.totalMats += %fromCl - %toCl;
						%cl.chatMessage("\c6Trade successful! List of traded materials:");
						%cl.lastTradeCmd = ""; servercmdMessageSent(%cl, "!List");
						%this.chatMessage("\c6Trade successful! List of traded materials:");
						%this.lastTradeCmd = ""; servercmdMessageSent(%this, "!List");
						%cl.tradingWith = ""; %this.tradingWith = "";
					}
				case "Add":
					if(getWordCount(%data) < 3)
					{ %cl.chatMessage("\c6Too few arguments. Usage: \"!Add 5 Oxygen\"."); return; }
					%amt = getWord(%data, 1);
					%mat = getWord(%data, 2);
					%mats = materialList();
					for(%i=0;%i<getWordCount(%mats);%i++)
						if(getWord(%mats, %i) $= %mat)
						{ %mat = getWord(%mats, %i); %flag = 1; }
					if(!%flag) { %cl.chatMessage("\c6There is no material "@strUpr(getSubStr(%mat, 0, 1)) @ strLwr(getSubStr(%mat, 1, strLen(%mat) - 1))@"!"); return; }
					%cl.trade[%mat] += %amt; %cl.trade[%mat] = getMin(%cl.trade[%mat], %cl.mat[%mat]); %cl.chatMessage("\c6Now trading "@mFloatLength(%cl.trade[%mat], 3) SPC %mat@".");
					%this.chatMessage("\c6"@%cl.name@" is now trading "@mFloatLength(%cl.trade[%mat], 3) SPC %mat@"."); %cl.acceptTrade = 0; %this.acceptTrade = 0;
				case "Cancel":
					%cl.chatMessage("\c6Cancelled trading.");
					%this.chatMessage("\c6"@%cl.name@" cancelled trading.");
					%cl.tradingWith = ""; %this.tradingWith = "";
				case "Help":
					%cl.chatMessage("\c6\"\c2!Accept\c6\" - \c3Accepts trading. Both parties must accept, and this is invalidated if either adds or removes materials.");
					%cl.chatMessage("\c6\"\c2!Add (Amount) (Material)\c6\" - \c3Adds an amount of material to trade.");
					%cl.chatMessage("\c6\"\c2!Cancel\c6\" - \c3Cancels trading completely.");
					%cl.chatMessage("\c6\"\c2!Help\c6\" - \c3Shows this list. Obviously.");
					%cl.chatMessage("\c6\"\c2!List\c6\" - \c3Lists all the materials both sides will trade.");
					%cl.chatMessage("\c6\"\c2!Remove (Amount) (Material)\c6\" - \c3Removes an amount of material to trade.");
				case "List":
					%mats = materialList();
					%cl.chatMessage("\c2"@%cl.name@"\c3 ==> \c2"@%this.name);
					for(%i=0;%i<getWordCount(%mats);%i++)
					{
						%mat = getWord(%mats, %i);
						if(%cl.trade[%mat] != 0)
						{ %cl.chatMessage("\c6"@mFloatLength(%cl.trade[%mat], 3) SPC %mat); %flag = 1; }
					}
					if(!%flag) %cl.chatMessage("\c6Nothing");
					%flag = 0;
					%cl.chatMessage("\c2"@%this.name@"\c3 ==> \c2"@%cl.name);
					for(%i=0;%i<getWordCount(%mats);%i++)
					{
						%mat = getWord(%mats, %i);
						if(%this.trade[%mat] != 0)
						{ %cl.chatMessage("\c6"@mFloatLength(%this.trade[%mat], 3) SPC %mat); %flag = 1; }
					}
					if(!%flag) %cl.chatMessage("\c6Nothing");
				case "Remove":
					if(getWordCount(%data) < 3)
					{ %cl.chatMessage("\c6Too few arguments. Usage: \"!Remove 5 Oxygen\"."); return; }
					%amt = getWord(%data, 1);
					%mat = getWord(%data, 2);
					%mats = materialList();
					for(%i=0;%i<getWordCount(%mats);%i++)
						if(getWord(%mats, %i) $= %mat)
						{ %mat = getWord(%mats, %i); %flag = 1; }
					if(!%flag) { %cl.chatMessage("\c6There is no material "@strUpr(getSubStr(%mat, 0, 1)) @ strLwr(getSubStr(%mat, 1, strLen(%mat) - 1))@"!"); return; }
					%cl.trade[%mat] -= %amt; %cl.trade[%mat] = getMax(%cl.trade[%mat], 0); %cl.chatMessage("\c6Now trading "@mFloatLength(%cl.trade[%mat], 3) SPC %mat@".");
					%this.chatMessage("\c6"@%cl.name@" is now trading "@mFloatLength(%cl.trade[%mat], 3) SPC %mat@"."); %cl.acceptTrade = 0; %this.acceptTrade = 0;
				case "Trade": servercmdTrade(%cl, restWords(%msg));
			}
			return;
		}
		Parent::servercmdMessageSent(%cl, %msg);
	}
};
activatePackage("RSM_Trading");

function servercmdTrade(%cl, %vict)
{
	%targ = findClientByName(%vict);
	if(!isObject(%pl = %cl.player) || !isObject(%obj = %targ.player))
	{ %cl.chatMessage("\c6Can't trade with "@%targ.name@" - you must both be alive!"); return; }
	if(isObject(%this = %cl.tradingWith)) { %cl.chatMessage("\c6Can't trade with "@%targ.name@" - you're already trading with "@%this.name@"!"); return; }
	if(isObject(%this = %targ.tradingWith)) { %cl.chatMessage("\c6Can't trade with "@%targ.name@" - they're already trading with "@%this.name@"!"); return; }
	if(vectorDist(%pl.getHackPosition(), %obj.getHackPosition()) > 8)
	{ %cl.chatMessage("\c6Can't trade with "@%targ.name@" - you're too far away!"); return; }
	//Maybe add line-of-sight testing as well, but not just yet.
	%cl.chatMessage("\c6Trade invite sent! Type \"!Help\" for a list of commands.");
	%targ.chatMessage("\c6"@%cl.name@" is trading with you. Type \"!Help\" for a list of commands.");
	%mats = materialList();
	for(%i=0;%i<getWordCount(%mats);%i++)
	{
		%mat = getWord(%mats, %i);
		%targ.trade[%mat] = 0;
		%cl.trade[%mat] = 0;
	}
	%cl.acceptTrade = 0; %targ.acceptTrade = 0;
	%targ.tradingWith = %cl; %cl.tradingWith = %targ;
	tradeCheckLoop(%cl, %targ);
}

function tradeCheckLoop(%clA, %clB)
{
	if(!isObject(%clA) || !isObject(%clB))
	{ if(isObject(%clA)) %clA.tradingWith = ""; if(isObject(%clB)) %clB.tradingWith = ""; return; }
	if(%clA.tradingWith != %clB || %clB.tradingWith != %clA)
	{ %clA.tradingWith = ""; %clB.tradingWith = ""; return; }
	if(!isObject(%plA = %clA.player) || !isObject(%plB = %clB.player))
	{ %clA.tradingWith = ""; %clB.tradingWith = ""; return; }
	if(vectorDist(%plA.getHackPosition(), %plB.getHackPosition()) > 8.75)
	{
		%clA.tradingWith = ""; %clA.chatMessage("Trade with "@%clB.name@" cancelled - you're too far away!");
		%clB.tradingWith = ""; %clB.chatMessage("Trade with "@%clA.name@" cancelled - you're too far away!");
		return;
	}
	schedule(50, 0, "tradeCheckLoop", %clA, %clB);
}