datablock fxDtsBrickData(brickTurretRoofData)
{
	brickFile = "./Bricks/Turret Up.blb";
	category = "Space Mod";
	subCategory = "Station Defenses";
	uiName = "Roof-Mounted Turret";
	iconName = "Add-Ons/Server_SpaceRP/Brick/Turret Up";
};

function brickTurretRoofData::onAdd(%data, %brick)
{
	%brick.delete();
	%shape = new StaticShape()
	{
		datablock = RSM_CubeCol1Shape;
		position = vectorAdd(%brick.getPosition(), "1 0 -0.5");
		scale = "1 0.1 0.1";
	};
	%shape.setNodeColor("ALL", "0.5 0.5 0.5 1");
	%brick.turretMuzzle = %shape;
	%shape.muzzleCenter = vectorAdd(%brick.getPosition(), "0 0 -0.5");
	schedule(50, 0, "TurretAILoop", %brick, %shape);
}

function TurretAILoop(%brick, %shape)
{
	if(!isObject(%brick) && isObject(%shape)) %shape.delete();
	if(!isObject(%shape)) return;
	initContainerRadiusSearch(%center = %shape.muzzleCenter, 160, $Typemasks::PlayerObjectType);
	%bl_id = %brick.getGroup().bl_id;   //Turn this into a permissions thing instead
	while(isObject(%obj = containerSearchNext()))
	{
		if(%obj.client.bl_id == %bl_id || %obj.client.ownerBL_ID == %bl_id) continue;
		%pos = %obj.getHackPosition(); %vel = %obj.getVelocity();
		%aimPos = %pos; %aimVel = %vel;
		%speed = 70;   //Projectile speed.
		for(%i=0;%i<20;%i++)
		{
			%time = (vectorDist(%aimPos, %center) - 2) / %speed;
			%aimPos = vectorAdd(%pos, vectorScale(%aimVel, %time));
		}
		if(isObject(containerRaycast(%center, %aimPos, $Typemasks::fxBrickObjectType))) continue;
		if(%time < %least || %least $= "") { %least = %time; %finalAim = %aimPos; %pl = %obj; }
	}
	if(%least !$= "")
	{
		%aim = vectorNormalize(%dir = vectorSub(%finalAim, %center));
		if(vectorDist(%shape.lastProj, %now = getSimTime()) > 200)
		{
			%proj = new Projectile()
			{
				datablock = ArrowProjectile;
				initialPosition = vectorAdd(%center, vectorScale(%aim, 2));
				initialVelocity = vectorScale(%aim, 70);
				client = findClientByName(Xal);   //Replace this
			};
			%shape.lastProj = %now;
		}
	}
	schedule(50, 0, "TurretAILoop", %brick, %shape);
}