exec("Add-Ons/Weapon_Gun/Server.cs");

datablock DebrisData(SpaceGunShellDebris : GunShellDebris)
{ fade = 0; lifetime = 10; numBounces = 10; gravModifier = 0; };

datablock ExplosionData(SpaceGunExplosion : GunExplosion)
{
	soundProfile = "";
};

datablock ProjectileData(SpaceGunProjectile : GunProjectile)
{
	impactImpulse = 0;
	verticalImpulse = 0;
	explosion = SpaceGunExplosion;
	uiName = "";
};

datablock ItemData(SpaceGunItem : GunItem)
{
	canDrop = false;
	colorShiftColor = "0.1 0.1 0.1 1";
	image = SpaceGunImage;
};

datablock ShapeBaseImageData(SpaceGunImage : GunImage)
{
	casing = SpaceGunShellDebris;
	colorShiftColor = "0.1 0.1 0.1 1";
	correctMuzzleVector = 0;
	item = SpaceGunItem;
	projectile = "";
	
	stateScript[0] = "onDraw";
	stateSound[0] = "";
	stateTransitionOnTimeout[0] = "AmmoCheck";
	stateSound[2] = "";
	stateSequence[4] = "AmmoCheck";
	stateTransitionOnTriggerUp[4] = "AmmoCheck";
	
	stateName[5] = "AmmoCheck";
	stateTransitionOnAmmo[5] = "Ready";
	stateTransitionOnTriggerDown[5] = "DryFire";
	
	stateName[6] = "DryFire";
	stateScript[6] = "onDryFire";
	stateSequence[6] = "DryFire";
	stateTransitionOnTriggerUp[6] = "AmmoCheck";
};

function SpaceGunImage::onDraw(%this, %obj, %slot)
{ serverPlay3DSpace(WeaponSwitchSound, %obj.getMuzzlePoint(0)); %obj.setImageAmmo(0, %obj.ammo45 >= 1); }

function SpaceGunImage::onDryFire(%this, %obj, %slot)
{ %obj.playThread(2, "brickPlant"); serverPlay3DSpace(BrickPlantSound, %obj.getMuzzlePoint(0)); }

function SpaceGunImage::onFire(%this, %obj, %slot)
{
	if(%obj.ammo45 >= 1)
	{
		%obj.ammo45--;
		%now = getSimTime();
		if(%obj.getDamagePercent() < 1.0)
			%obj.playThread(2, "shiftAway");
		%mPos = %obj.getMuzzlePoint(0);
		serverPlay3DSpace(GunShot1Sound, %mPos);
		%force = (300 * 0.012) / (%obj.getMass() / 2);   //Get the force in terms of m/s*kg
		%mDir = %obj.getMuzzleVector(0);
		%obj.addVelocity(vectorScale(%mDir, -%force));
		bulletSim(%mPos, vectorAdd(%obj.getVelocity(), vectorScale(%mDir, convertMetersToTU(300))), %now, %now, %obj, 0);
	}
	else
	{
		if(%obj.getDamagePercent() < 1.0)
			%obj.playThread(2, "brickPlant");
		%mPos = %obj.getMuzzlePoint(0);
		serverPlay3DSpace(brickPlantSound, %mPos);   //Replace when the space sound for planting is implemented
	}
	%obj.setImageAmmo(0, %obj.ammo45 >= 1);
}

function bulletSim(%pos, %vel, %last, %start, %obj, %noPVP)
{
	%time = vectorDist(%last, %now = getSimTime()) / 1000;
	if(vectorDist(%now, %start) > 30000) return;
	%end = vectorAdd(%pos, vectorScale(%vel, %time));
	%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType;
	%moveable = $Typemasks::PlayerObjectType;
	%ray = containerRaycast(%pos, %end, %mask, %obj);
	if(!%noPVP)   //Don't bother running this check if we already can't do damage
	{
		%closest = GetClosestPoint(%pos, %end, "0 0 256.3");
		if(vectorDist(%closest, "0 0 "@(34.1383*$RSM::AsteroidDist)) <= $RSM::AsteroidDist * 3)
			%noPVP = 1;   //No-PVP bubble around the spawn station of 3x the asteroid distance.
	}
	while(isObject(%hit = firstWord(%ray)))
	{
		if(%hit.getClassName() $= "fxDtsBrick" && %hit.isColliding() == 0)
		{ %ray = containerRaycast(getWords(%ray, 1, 3), %end, %mask, %obj, %hit); continue; }
		(%proj = new Projectile()
		{
			client = %obj.client;
			datablock = SpaceGunProjectile;
			initialPosition = getWords(%ray, 1, 3);
			initialVelocity = "0 0 0";
		}).explode();
		serverPlay3DSpace(BulletHitSound, getWords(%ray, 1, 3));
		if(%hit.getType() & $Typemasks::PlayerObjectType)
		{
			%force = 3.6 / (%hit.getMass() / 2); %hit.addVelocity(vectorScale(vectorNormalize(%vel), %force));
			if(!%noPVP) %hit.damage(%proj, getWords(%ray, 1, 3), SpaceGunProjectile.directDamage, $DamageType::Gun);
		}
		return;
	}
	schedule(16, 0, "bulletSim", %end, %vel, %now, %start, %obj, %noPVP);
}

GunItem.uiName = "";